function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React from 'react';
import classnames from 'classnames';
import { Icon } from 'antd-mobile-v2';
import CSSTransition from 'react-transition-group/CSSTransition';
import ExpandView from "./components/ExpandView";
import useToggle from "../../hooks/useToggle";
import { allPrefixCls } from "../../const/index";
import "./index.less";
import { CardContext } from "../Context";
var prefixCls = "".concat(allPrefixCls, "-card");
var prefixClsExtends = "".concat(prefixCls, "-extends");

var Card = function Card(_ref) {
  var _classnames;

  var children = _ref.children,
      leftView = _ref.leftView,
      required = _ref.required,
      title = _ref.title,
      rightView = _ref.rightView,
      className = _ref.className,
      _ref$border = _ref.border,
      border = _ref$border === void 0 ? true : _ref$border,
      _ref$extandPostion = _ref.extandPostion,
      extandPostion = _ref$extandPostion === void 0 ? '' : _ref$extandPostion,
      _ref$defaultExtand = _ref.defaultExtand,
      defaultExtand = _ref$defaultExtand === void 0 ? true : _ref$defaultExtand,
      extandChange = _ref.extandChange,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$hideStar = _ref.hideStar,
      hideStar = _ref$hideStar === void 0 ? false : _ref$hideStar,
      boxStyle = _ref.boxStyle,
      titleStyle = _ref.titleStyle;

  var _useToggle = useToggle(defaultExtand),
      _useToggle2 = _slicedToArray(_useToggle, 2),
      isExtand = _useToggle2[0],
      toggleExtand = _useToggle2[1];

  return /*#__PURE__*/React.createElement(CardContext.Provider, {
    value: {
      cDisabled: disabled
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames = {}, _defineProperty(_classnames, prefixCls, true), _defineProperty(_classnames, "".concat(prefixCls, "-border"), border), _classnames), className),
    style: boxStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title-box")
  }, leftView, required && !hideStar && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-require")
  }, "*"), title && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title"),
    style: titleStyle
  }, title), rightView && rightView, extandPostion === 'top' && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-extends-icon"),
    onClick: function onClick() {
      toggleExtand();
      if (extandChange) extandChange(!isExtand);
    }
  }, /*#__PURE__*/React.createElement(Icon, {
    size: "xxs",
    type: isExtand ? 'up' : 'down'
  }))), /*#__PURE__*/React.createElement("div", {
    className: prefixClsExtends
  }, /*#__PURE__*/React.createElement(CSSTransition, {
    in: isExtand,
    classNames: "".concat(prefixClsExtends, "-body"),
    timeout: 200
  }, function (state) {
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixClsExtends, "-body")
    }, /*#__PURE__*/React.createElement("div", {
      className: classnames("".concat(prefixClsExtends, "-animation"), _defineProperty({}, "".concat(prefixClsExtends, "-entered"), state === 'entered'))
    }, children), extandPostion === 'bottom' && /*#__PURE__*/React.createElement(ExpandView, {
      isExtand: isExtand,
      onChange: function onChange() {
        toggleExtand();
        if (extandChange) extandChange(!isExtand);
      }
    }));
  }))));
};

export default Card;