var _excluded = ["type", "disabled", "renderHeader"];

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useState } from 'react';
import Form, { useForm } from 'rc-field-form';
import { getByteLen } from "../../utils";
import { DFORM_COMP_NAME } from "../../utils/menu";
import Group from "./Group";
import { DformInput, DformSelect, DformSwitch, DformTextArea, DformDatePicker, ExtraInput, RangeDatePicker, DformRadio, DformCheckBox, CoverRadio, DformImagePicker, DformCustom, MultiplePicker, AddressPicker, DformText, DformPicker, DformFile } from "../../components";
import Title from "../Title";
import NewFieldPicker from "../NewFieldPicker/NewFieldPicker";
var FormItemType = {
  input: DformInput,
  select: DformSelect,
  area: DformTextArea,
  date: DformDatePicker,
  switch: DformSwitch,
  radio: DformRadio,
  extraInput: ExtraInput,
  rangeDatePicker: RangeDatePicker,
  checkbox: DformCheckBox,
  coverRadio: CoverRadio,
  image: DformImagePicker,
  custom: DformCustom,
  multiplePicker: MultiplePicker,
  addressPicker: AddressPicker,
  text: DformText,
  picker: DformPicker,
  file: DformFile
};
export var getFormItem = function getFormItem(formItem, allDisabled, errorValue) {
  var type = formItem.type,
      _formItem$disabled = formItem.disabled,
      disabled = _formItem$disabled === void 0 ? allDisabled : _formItem$disabled,
      renderHeader = formItem.renderHeader,
      otherProps = _objectWithoutProperties(formItem, _excluded);

  var FormItemComponent = FormItemType[formItem.type];
  return /*#__PURE__*/React.createElement(Title, {
    key: otherProps === null || otherProps === void 0 ? void 0 : otherProps.fieldProps,
    type: type // error={errorValue}
    // positionType={
    //   otherProps?.positionType || DFORM_COMP_DETAULT[type].positionType
    // }
    // hidden={otherProps?.hidden}
    // required={otherProps?.required}
    // hasStar={otherProps?.hasStar}
    // title={otherProps?.title}
    // subTitle={otherProps?.subTitle}
    // extra={otherProps?.extra || ''}
    // fieldProps={otherProps?.fieldProps}

  }, renderHeader, /*#__PURE__*/React.createElement(FormItemComponent, _extends({}, otherProps, {
    disabled: disabled,
    errorValue: errorValue
  })));
};
export var defaultFailed = function defaultFailed(errorInfo, onFinishFailed, failScroll) {
  if (!errorInfo || !errorInfo.errorFields || errorInfo.errorFields.length === 0) {
    if (onFinishFailed) onFinishFailed(errorInfo);
    return;
  }

  var scrollToField = function scrollToField(fieldKey) {
    var labelNode = document.getElementById("alita-dform-".concat(fieldKey));

    if (labelNode && labelNode.scrollIntoView) {
      var _labelNode$scrollInto;

      (_labelNode$scrollInto = labelNode.scrollIntoView) === null || _labelNode$scrollInto === void 0 ? void 0 : _labelNode$scrollInto.call(labelNode, {
        behavior: 'smooth',
        block: 'center',
        inline: 'center'
      });
    }
  };

  if (failScroll) scrollToField(errorInfo.errorFields[0].name[0]);
  if (onFinishFailed) onFinishFailed(errorInfo);
};

var changeData = function changeData(oldData, autoLineFeed) {
  return oldData.map(function (item) {
    if (item !== null && item !== void 0 && item.hidden) {
      item.required = false;
    }

    if (item.positionType === 'vertical' || !autoLineFeed) return item;

    if (item.title) {
      var titleSize = getByteLen(item.title);

      if (titleSize >= 16) {
        item.positionType = 'vertical';
      } else if (item.type === 'input' || item.type === 'extraInput') {
        if (titleSize > 8) {
          item.labelNumber = titleSize / 2 + 1;
        } else {
          item.labelNumber = 7;
        }
      }
    }

    return item;
  });
};

var renderListMain = function renderListMain(_ref) {
  var _ref$formData = _ref.formData,
      formData = _ref$formData === void 0 ? [] : _ref$formData,
      _ref$allDisabled = _ref.allDisabled,
      allDisabled = _ref$allDisabled === void 0 ? false : _ref$allDisabled,
      _ref$autoLineFeed = _ref.autoLineFeed,
      autoLineFeed = _ref$autoLineFeed === void 0 ? true : _ref$autoLineFeed,
      _ref$errorValue = _ref.errorValue,
      errorValue = _ref$errorValue === void 0 ? {} : _ref$errorValue;
  return /*#__PURE__*/React.createElement(React.Fragment, null, changeData(formData, autoLineFeed).map(function (item) {
    return getFormItem(item, allDisabled, errorValue);
  }));
};
/**
 * 通过 onFinishFailed 的方法
 */


var getAllError = function getAllError(errorInfo) {
  var _errorInfo$errorField = errorInfo.errorFields,
      errorFields = _errorInfo$errorField === void 0 ? [] : _errorInfo$errorField;
  var errorObj = {};
  errorFields.forEach(function (item) {
    errorObj[item["name"][0]] = item["errors"][0];
  });
  return errorObj;
};
/**
 * 重置错误信息提示
 */


var resetErrorField = function resetErrorField(errorValue, values) {
  var errorObj = _objectSpread({}, errorValue);

  var key = Object.keys(values)[0];

  if (errorObj[key]) {
    errorObj[key] = undefined;
    return {
      success: true,
      errorObj: errorObj
    };
  } else {
    return {
      success: false
    };
  }
};

var DynamicForm = function DynamicForm(_ref2) {
  var children = _ref2.children,
      _ref2$data = _ref2.data,
      data = _ref2$data === void 0 ? [] : _ref2$data,
      form = _ref2.form,
      _ref2$allDisabled = _ref2.allDisabled,
      allDisabled = _ref2$allDisabled === void 0 ? false : _ref2$allDisabled,
      _ref2$formsValues = _ref2.formsValues,
      formsValues = _ref2$formsValues === void 0 ? {} : _ref2$formsValues,
      onFinish = _ref2.onFinish,
      _onFinishFailed = _ref2.onFinishFailed,
      _onValuesChange = _ref2.onValuesChange,
      isDev = _ref2.isDev,
      _ref2$autoLineFeed = _ref2.autoLineFeed,
      autoLineFeed = _ref2$autoLineFeed === void 0 ? true : _ref2$autoLineFeed,
      _ref2$failScroll = _ref2.failScroll,
      failScroll = _ref2$failScroll === void 0 ? true : _ref2$failScroll,
      _ref2$relatives = _ref2.relatives,
      relatives = _ref2$relatives === void 0 ? {} : _ref2$relatives;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      defaultValueFlag = _useState2[0],
      setDefaultValueFlag = _useState2[1];

  var _useState3 = useState({}),
      _useState4 = _slicedToArray(_useState3, 2),
      errorValue = _useState4[0],
      setErrorValue = _useState4[1];

  var _useState5 = useState({}),
      _useState6 = _slicedToArray(_useState5, 2),
      changeForm = _useState6[0],
      setChangeForm = _useState6[1];

  useEffect(function () {
    if (defaultValueFlag) {
      if (data && data.length) {
        var filter = data.filter(function (dataItem) {
          return (dataItem === null || dataItem === void 0 ? void 0 : dataItem.defaultValue) !== undefined && formsValues[dataItem === null || dataItem === void 0 ? void 0 : dataItem.fieldProps] === undefined;
        });

        if (filter && filter.length) {
          filter.forEach(function (filterItem) {
            formsValues[filterItem === null || filterItem === void 0 ? void 0 : filterItem.fieldProps] = filterItem.defaultValue;
          });
          setDefaultValueFlag(false);
        }
      }
    }

    form.setFieldsValue(formsValues);
  }, [formsValues]);
  var childs = React.Children.toArray(children); // 字段变更联动

  var fieldChange = function fieldChange(fieldProps, e, relatives) {
    // 当前表单规则
    var curFieldRel = relatives[fieldProps]; // 改变表单字段

    var mChangeForm = {};

    if (!!Object.keys(relatives).length && !!curFieldRel && !!curFieldRel.length) {
      curFieldRel.forEach(function (rel) {
        var type = rel.type,
            targetValue = rel.targetValue,
            _rel$targetSet = rel.targetSet,
            targetSet = _rel$targetSet === void 0 ? [] : _rel$targetSet;
        var fieldValues = {};

        switch (type) {
          case 'changeFormValue':
            if (targetValue.includes(e)) {
              targetSet.forEach(function (row) {
                var targetField = row.targetField,
                    targetValue = row.targetValue;
                fieldValues[targetField] = targetValue;
              });
              form.setFieldsValue(fieldValues);
            }

            break;

          case 'required':
          case 'hidden':
          case 'disabled':
            targetSet.forEach(function (row) {
              var targetField = row.targetField;
              mChangeForm[targetField] = _defineProperty({}, type, targetValue.includes(e));
            });
            break;

          case 'custom':
            targetSet.forEach(function (row) {
              var targetField = row.targetField,
                  _row$targetContent = row.targetContent,
                  targetContent = _row$targetContent === void 0 ? {} : _row$targetContent;
              mChangeForm[targetField] = targetValue.includes(e) ? targetContent : {};
            });
            break;

          default:
            break;
        }
      });

      if (!!Object.keys(mChangeForm).length) {
        setChangeForm(_objectSpread(_objectSpread({}, changeForm), mChangeForm));
      }
    }
  };

  var dformItems = function dformItems(childs) {
    return childs.map(function (child, index) {
      if (! /*#__PURE__*/React.isValidElement(child)) return;
      var _child$props = child.props,
          props = _child$props === void 0 ? {} : _child$props;

      var mProps = _objectSpread(_objectSpread({}, props), changeForm[props.fieldProps] || {});

      var positionType = mProps.positionType,
          hidden = mProps.hidden,
          _mProps$required = mProps.required,
          required = _mProps$required === void 0 ? false : _mProps$required,
          _mProps$hasStar = mProps.hasStar,
          hasStar = _mProps$hasStar === void 0 ? true : _mProps$hasStar,
          title = mProps.title,
          subTitle = mProps.subTitle,
          extra = mProps.extra,
          fieldProps = mProps.fieldProps;
      var _ref3 = child.type,
          name = _ref3.name;

      if (DFORM_COMP_NAME.indexOf(name) !== -1) {
        return /*#__PURE__*/React.createElement(Title, {
          type: name,
          key: fieldProps || index // error={errorValue}
          // positionType={positionType || DFORM_COMP_DETAULT[name].positionType}
          // hidden={hidden}
          // required={required}
          // hasStar={hasStar}
          // title={title}
          // subTitle={subTitle}
          // extra={extra}
          // fieldProps={fieldProps}

        }, /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread({}, mProps), {}, {
          errorValue: errorValue,
          onChange: function onChange(e) {
            var _ref4 = mProps,
                onChange = _ref4.onChange;
            fieldChange(fieldProps, e, relatives);
            if (onChange) onChange(e);
          }
        }))); // } else if (name === 'Group') {
        //   return React.cloneElement(child, {
        //     ...props,
        //     children: child,
        //   });
      } else {
        return child;
      }
    });
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Form, {
    form: form,
    initialValues: formsValues,
    onFinish: onFinish,
    onFinishFailed: function onFinishFailed(errorInfo) {
      setErrorValue(getAllError(errorInfo));
      defaultFailed(errorInfo, _onFinishFailed, failScroll);
    },
    onValuesChange: function onValuesChange(values) {
      var _resetErrorField = resetErrorField(errorValue, values),
          _resetErrorField$succ = _resetErrorField.success,
          success = _resetErrorField$succ === void 0 ? false : _resetErrorField$succ,
          errorObj = _resetErrorField.errorObj;

      if (success) setErrorValue(errorObj);
      if (_onValuesChange) _onValuesChange(values);
    }
  }, !!data.length && renderListMain({
    formData: data,
    allDisabled: allDisabled,
    autoLineFeed: autoLineFeed,
    errorValue: errorValue
  }), childs && typeof children === 'function' && children({
    errorValue: errorValue
  }), childs && dformItems(childs)), isDev && /*#__PURE__*/React.createElement(NewFieldPicker, {
    data: data
  }));
}; // 为自定义 useForm 预留入口


export { useForm }; //@ts-ignore

DynamicForm.Group = Group;
export default DynamicForm;