function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect } from 'react';
import classnames from 'classnames'; // @ts-ignore

import ClosePng from "../../assets/close.png";
import { allPrefixCls } from "../../const/index";
import "./index.less";
var prefixCls = 'alitajs-dform-text-item';

var checkValue = function checkValue(val) {
  if (val) return true;
  if (val === 0) return true;
  return false;
};

var TextItem = function TextItem(props) {
  var _classnames, _classnames2, _classnames3, _classnames4, _classnames5;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      overflowFlag = _useState2[0],
      setOverflowFlag = _useState2[1]; // 展开收起标识


  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      lineHeightFlag = _useState4[0],
      setLineHeightFlag = _useState4[1]; // 文字行数是否超过 maxLength


  var _useState5 = useState({}),
      _useState6 = _slicedToArray(_useState5, 2),
      currentCoverStyle = _useState6[0],
      setCurrentCoverStyle = _useState6[1];

  var _props$isVertical = props.isVertical,
      isVertical = _props$isVertical === void 0 ? false : _props$isVertical,
      _props$value = props.value,
      value = _props$value === void 0 ? '' : _props$value,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '请输入' : _props$placeholder,
      onClick = props.onClick,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      _props$coverStyle = props.coverStyle,
      coverStyle = _props$coverStyle === void 0 ? {} : _props$coverStyle,
      extra = props.extra,
      maxLine = props.maxLine,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      fieldProps = props.fieldProps,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      _props$arrow = props.arrow,
      arrow = _props$arrow === void 0 ? true : _props$arrow,
      _props$ellipsis = props.ellipsis,
      ellipsis = _props$ellipsis === void 0 ? true : _props$ellipsis,
      _props$clear = props.clear,
      clear = _props$clear === void 0 ? false : _props$clear,
      _props$clearClick = props.clearClick,
      clearClick = _props$clearClick === void 0 ? function () {} : _props$clearClick;
  useEffect(function () {
    var textIds = document.getElementById("text-".concat(fieldProps));

    if (textIds) {
      var lineHeight = window.getComputedStyle(textIds, null).lineHeight;
      var delValue = ((textIds === null || textIds === void 0 ? void 0 : textIds.clientHeight) + 2) / parseInt(lineHeight, 10);

      if (maxLine) {
        // eslint-disable-next-line prefer-destructuring
        if (delValue > maxLine) {
          setLineHeightFlag(true);
        } else {
          setLineHeightFlag(false);
        }
      }
    }
  }, [value]);
  useEffect(function () {
    var _Object$keys;

    if (coverStyle && (_Object$keys = Object.keys(coverStyle)) !== null && _Object$keys !== void 0 && _Object$keys.length) {
      var newStyle = JSON.parse(JSON.stringify(coverStyle));
      if (!checkValue(value) && coverStyle.color) delete newStyle.color;
      setCurrentCoverStyle(_objectSpread({}, newStyle));
    }
  }, [value, coverStyle]);
  var labelCls = classnames((_classnames = {}, _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-0"), labelNumber === 0), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-2"), labelNumber === 2), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-3"), labelNumber === 3), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-4"), labelNumber === 4), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-5"), labelNumber === 5), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-6"), labelNumber === 6), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-7"), labelNumber === 7), _defineProperty(_classnames, "".concat(allPrefixCls, "-input-label-auto"), labelNumber > 7), _classnames));

  var inputItemClick = function inputItemClick() {
    if (disabled) return;
    if (onClick) onClick(value);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, !isVertical && /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames2 = {}, _defineProperty(_classnames2, labelCls, true), _defineProperty(_classnames2, "".concat(allPrefixCls, "-input-label-min-width"), (value === null || value === void 0 ? void 0 : value.length) > 10), _classnames2))
  }, props.children), /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames3 = {}, _defineProperty(_classnames3, "".concat(prefixCls, "-value"), true), _defineProperty(_classnames3, "".concat(allPrefixCls, "-ellipsis"), ellipsis), _defineProperty(_classnames3, "".concat(prefixCls, "-min-width"), labelNumber > 7), _classnames3))
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames4 = {}, _defineProperty(_classnames4, "".concat(prefixCls, "-content"), !!checkValue(value)), _defineProperty(_classnames4, "".concat(prefixCls, "-content-padding"), !isVertical), _defineProperty(_classnames4, "".concat(allPrefixCls, "-placeholder"), !checkValue(value)), _defineProperty(_classnames4, "".concat(allPrefixCls, "-ellipsis"), ellipsis), _classnames4)),
    onClick: function onClick() {
      inputItemClick();
    }
  }, /*#__PURE__*/React.createElement("div", {
    id: "text-".concat(fieldProps),
    className: classnames((_classnames5 = {}, _defineProperty(_classnames5, "".concat(prefixCls, "-text"), true), _defineProperty(_classnames5, 'alitajs-dform-disabled', disabled && checkValue(value)), _defineProperty(_classnames5, className, className), _classnames5)),
    style: _objectSpread({
      textAlign: isVertical ? 'left' : 'right',
      WebkitLineClamp: maxLine,
      display: maxLine && overflowFlag && lineHeightFlag ? '-webkit-box' : ''
    }, currentCoverStyle)
  }, checkValue(value) ? "".concat(value) : placeholder), maxLine && lineHeightFlag && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-overflow"),
    onClick: function onClick() {
      setOverflowFlag(!overflowFlag);
    }
  }, overflowFlag ? '更多' : '收起')), clear && checkValue(value) && !disabled && /*#__PURE__*/React.createElement("img", {
    className: "".concat(allPrefixCls, "-close"),
    src: ClosePng,
    alt: "",
    onClick: clearClick
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-right-content")
  }, arrow && !disabled && /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-arrow-horizontal")
  }), !isVertical && /*#__PURE__*/React.createElement("div", {
    className: "am-input-extra"
  }, extra)));
};

export default TextItem;