function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo, useContext, useState } from 'react';
import classnames from 'classnames';
import { DformContext } from "../Context";
import Hidden from "../Hidden";
import { allPrefixCls } from "../../const";
import { DFORM_COMP_DETAULT, NO_SUPPORT_VERTICAL } from "../../utils/menu";

var Title = function Title(props) {
  var _DFORM_COMP_DETAULT$t, _classnames, _classnames2;

  var children = props.children,
      _props$type = props.type,
      type = _props$type === void 0 ? '' : _props$type,
      _props$independentPro = props.independentProps,
      independentProps = _props$independentPro === void 0 ? {} : _props$independentPro,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      _props$titleStyle = props.titleStyle,
      titleStyle = _props$titleStyle === void 0 ? {} : _props$titleStyle;
  var _independentProps$hid = independentProps.hidden,
      hidden = _independentProps$hid === void 0 ? false : _independentProps$hid,
      _independentProps$req = independentProps.required,
      required = _independentProps$req === void 0 ? false : _independentProps$req,
      _independentProps$has = independentProps.hasStar,
      hasStar = _independentProps$has === void 0 ? true : _independentProps$has,
      _independentProps$tit = independentProps.title,
      title = _independentProps$tit === void 0 ? '' : _independentProps$tit,
      subTitle = independentProps.subTitle,
      extra = independentProps.extra,
      fieldProps = independentProps.fieldProps,
      renderFooter = independentProps.renderFooter,
      renderHeader = independentProps.renderHeader,
      fieldName = independentProps.fieldName;
  var fieldKey = fieldName || fieldProps;

  var _useState = useState(required),
      _useState2 = _slicedToArray(_useState, 2),
      mregedRequired = _useState2[0],
      setMregedRequired = _useState2[1];

  var _useState3 = useState(hidden),
      _useState4 = _slicedToArray(_useState3, 2),
      mregedHidden = _useState4[0],
      setMregedHidden = _useState4[1];

  var _useContext = useContext(DformContext),
      changeForm = _useContext.changeForm;

  useMemo(function () {
    var _changeForm$fieldKey, _changeForm$fieldKey3;

    if (((_changeForm$fieldKey = changeForm[fieldKey]) === null || _changeForm$fieldKey === void 0 ? void 0 : _changeForm$fieldKey.required) !== undefined) {
      var _changeForm$fieldKey2;

      setMregedRequired((_changeForm$fieldKey2 = changeForm[fieldKey]) === null || _changeForm$fieldKey2 === void 0 ? void 0 : _changeForm$fieldKey2.required);
    } else {
      setMregedRequired(required);
    }

    if (((_changeForm$fieldKey3 = changeForm[fieldKey]) === null || _changeForm$fieldKey3 === void 0 ? void 0 : _changeForm$fieldKey3.hidden) !== undefined) {
      var _changeForm$fieldKey4;

      setMregedHidden((_changeForm$fieldKey4 = changeForm[fieldKey]) === null || _changeForm$fieldKey4 === void 0 ? void 0 : _changeForm$fieldKey4.hidden);
    } else {
      setMregedHidden(hidden);
    }
  }, [changeForm[fieldKey], hidden, required]); // 表单对齐方向

  var positionType = independentProps.positionType || ((_DFORM_COMP_DETAULT$t = DFORM_COMP_DETAULT[type]) === null || _DFORM_COMP_DETAULT$t === void 0 ? void 0 : _DFORM_COMP_DETAULT$t.positionType); // 是否是不可变更对齐方式的表单类型

  if (NO_SUPPORT_VERTICAL.includes(type)) {
    var _DFORM_COMP_DETAULT$t2;

    positionType = (_DFORM_COMP_DETAULT$t2 = DFORM_COMP_DETAULT[type]) === null || _DFORM_COMP_DETAULT$t2 === void 0 ? void 0 : _DFORM_COMP_DETAULT$t2.positionType;
  } // @ts-ignore


  var _useContext2 = useContext(DformContext),
      _useContext2$errorVal = _useContext2.errorValue,
      errorValue = _useContext2$errorVal === void 0 ? {} : _useContext2$errorVal;

  var isVertical = positionType === 'vertical'; // `${allPrefixCls}-cell` 类名勿动，主要用来配置单一class 取消Group尾部下划线

  return /*#__PURE__*/React.createElement(Hidden, {
    hidden: mregedHidden
  }, renderHeader, /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-content"),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      borderBottom: style.background || style.backgroundColor || '0.01rem solid #e5e5e5'
    },
    className: classnames("".concat(allPrefixCls, "-cell"), (_classnames = {}, _defineProperty(_classnames, "".concat(allPrefixCls).concat(isVertical ? '-vertical' : '', "-item"), true), _defineProperty(_classnames, "".concat(allPrefixCls, "-error"), errorValue && !!errorValue[fieldKey]), _classnames))
  }, isVertical && /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames2 = {}, _defineProperty(_classnames2, "".concat(allPrefixCls, "-title"), true), _defineProperty(_classnames2, "".concat(allPrefixCls, "-vertical-title"), true), _classnames2))
  }, mregedRequired && hasStar && /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-redStar")
  }, "*"), /*#__PURE__*/React.createElement("div", {
    style: titleStyle
  }, title), subTitle, extra !== '' && isVertical && /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-extra")
  }, extra)), children, errorValue && !!errorValue[fieldKey] && /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-error-text")
  }, errorValue[fieldKey]), renderFooter)));
};

export default Title;