function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect, useRef } from 'react';
import { Modal, List } from 'antd-mobile-v2';
import classnames from 'classnames';
import TextItem from "../../baseComponents/TextItem";
import "./index.less";
var Item = List.Item;

var AddressPickerGroup = function AddressPickerGroup(props) {
  var fieldProps = props.fieldProps,
      _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '请选择' : _props$placeholder,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      title = props.title,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      onChangeLevel = props.onChangeLevel,
      onChange = props.onChange,
      _props$placeholderLis = props.placeholderList,
      placeholderList = _props$placeholderLis === void 0 ? [] : _props$placeholderLis,
      _props$value = props.value,
      value = _props$value === void 0 ? undefined : _props$value,
      children = props.children,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 5 : _props$labelNumber,
      coverStyle = props.coverStyle,
      onClick = props.onClick,
      _props$height = props.height,
      height = _props$height === void 0 ? '70vh' : _props$height,
      _props$rightContent = props.rightContent,
      rightContent = _props$rightContent === void 0 ? '确定' : _props$rightContent,
      _props$leftContent = props.leftContent,
      leftContent = _props$leftContent === void 0 ? '取消' : _props$leftContent,
      _props$noData = props.noData,
      noData = _props$noData === void 0 ? '' : _props$noData,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      _props$alias = props.alias,
      alias = _props$alias === void 0 ? {
    label: 'label',
    value: 'value'
  } : _props$alias,
      arrow = props.arrow,
      onChangeVerifies = props.onChangeVerifies,
      extra = props.extra;
  var _alias$label = alias.label,
      label = _alias$label === void 0 ? 'label' : _alias$label;

  var _useState = useState(''),
      _useState2 = _slicedToArray(_useState, 2),
      inputLabel = _useState2[0],
      setInputLabel = _useState2[1]; // input 框的值


  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      modalFlag = _useState4[0],
      setModalFlag = _useState4[1]; // 弹框标识
  // 弹框选中的头部文字列表


  var _useState5 = useState([]),
      _useState6 = _slicedToArray(_useState5, 2),
      labelList = _useState6[0],
      setLabelList = _useState6[1];

  var _useState7 = useState([]),
      _useState8 = _slicedToArray(_useState7, 2),
      valueList = _useState8[0],
      setValueList = _useState8[1]; // value 值列表


  var isVertical = positionType === 'vertical';
  var addressPickerRef = useRef();

  var _useState9 = useState([]),
      _useState10 = _slicedToArray(_useState9, 2),
      list = _useState10[0],
      setList = _useState10[1];

  var _useState11 = useState(false),
      _useState12 = _slicedToArray(_useState11, 2),
      lastLevel = _useState12[0],
      setLastLevel = _useState12[1];

  var _useState13 = useState(0),
      _useState14 = _slicedToArray(_useState13, 2),
      curReqLevel = _useState14[0],
      setCurReqLevel = _useState14[1]; // 当前请求层级


  var _useState15 = useState(false),
      _useState16 = _slicedToArray(_useState15, 2),
      initReq = _useState16[0],
      setInitReq = _useState16[1]; // 用于记录是否已经初始化请求过


  var _useState17 = useState(true),
      _useState18 = _slicedToArray(_useState17, 2),
      openReq = _useState18[0],
      setOpenReq = _useState18[1]; // 打开是否需要请求


  var _useState19 = useState(false),
      _useState20 = _slicedToArray(_useState19, 2),
      isConfirm = _useState20[0],
      setIsConfirm = _useState20[1];

  useEffect(function () {
    if (!!data.length) setList(data);
    if (!modalFlag) return;

    if (!!data.length) {
      if (!initReq) setLastLevel(false);

      var newLabelList = _toConsumableArray(labelList);

      var labelListLength = labelList.length;
      if (valueList.length === newLabelList.length && valueList.length === curReqLevel) newLabelList.push(placeholderList[labelListLength] || '请选择');
      setLabelList(newLabelList);

      if (addressPickerRef && addressPickerRef.current) {
        addressPickerRef.current.scrollTop = 0;
      }
    } else if (!list.length) {
      // 初始化存在默认值
      if (!!valueList.length) {
        var initValueList = JSON.parse(JSON.stringify(valueList));

        if (initReq) {
          initValueList.pop();
          setLastLevel(true);
        }

        onMChangeLevel(initValueList, true);
      } else {
        onMChangeLevel([]);
      }
    } else {
      if (initReq) {
        var _initValueList = JSON.parse(JSON.stringify(valueList));

        _initValueList.pop();

        setLastLevel(true);
        onMChangeLevel(_initValueList, true);
      } else {
        setLastLevel(true);
      }
    }
  }, [data]);
  useEffect(function () {
    var _newValue$value;

    if (!value || isConfirm) {
      if (isConfirm) {
        setIsConfirm(false);
      }

      return;
    }

    var newValue = JSON.parse(JSON.stringify(value));

    if (valueList.toString() !== (newValue === null || newValue === void 0 ? void 0 : (_newValue$value = newValue.value) === null || _newValue$value === void 0 ? void 0 : _newValue$value.toString())) {
      var _newValue$value2;

      setInputLabel(((newValue === null || newValue === void 0 ? void 0 : newValue.label) || []).join(' '));
      setValueList((newValue === null || newValue === void 0 ? void 0 : newValue.value) || []);
      setLabelList((newValue === null || newValue === void 0 ? void 0 : newValue.label) || []);
      setCurReqLevel((newValue === null || newValue === void 0 ? void 0 : (_newValue$value2 = newValue.value) === null || _newValue$value2 === void 0 ? void 0 : _newValue$value2.length) || 0);
      setOpenReq(true);
    } else if (!valueList.length) {
      setOpenReq(true);
    } else {
      setOpenReq(false);
    }
  }, [JSON.stringify(value)]);

  var onMChangeLevel = function onMChangeLevel() {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var initDef = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    setInitReq(initDef);
    setCurReqLevel(value.length);
    if (onChangeLevel) onChangeLevel(value);
  };

  var onConfirm = function onConfirm() {
    var mLabelList = _toConsumableArray(labelList);

    var newLabelList = mLabelList.splice(0, valueList.length | 0) || []; // 赋值

    var val;

    if (valueList && valueList.length) {
      val = {
        label: newLabelList,
        value: valueList
      };
    }

    onChange(val, 'change');

    if (onChangeVerifies && !onChangeVerifies(val)) {
      return;
    }

    setInputLabel(newLabelList.join(' '));
    setModalFlag(false); // 关闭弹框

    setIsConfirm(true);
    setOpenReq(false);
  };
  /**
   * 打开弹窗
   */


  var openMoal = function openMoal() {
    if (disabled) return;
    setModalFlag(true);
  }; // 关闭弹窗


  var closeModal = function closeModal() {
    setModalFlag(false);

    if (!!value) {
      var newValue = JSON.parse(JSON.stringify(value));
      setTimeout(function () {
        var _newValue$value3, _newValue$value4;

        if (lastLevel && curReqLevel === (newValue === null || newValue === void 0 ? void 0 : (_newValue$value3 = newValue.value) === null || _newValue$value3 === void 0 ? void 0 : _newValue$value3.length) + 1) {
          setValueList(newValue === null || newValue === void 0 ? void 0 : newValue.value);
          var mLabelList = (newValue === null || newValue === void 0 ? void 0 : newValue.label) || [];
          mLabelList.push(placeholderList[mLabelList.length] || '请选择');
          setLabelList(mLabelList);
          setLastLevel(false);
          setOpenReq(false);
        } else if (valueList.toString() !== (newValue === null || newValue === void 0 ? void 0 : (_newValue$value4 = newValue.value) === null || _newValue$value4 === void 0 ? void 0 : _newValue$value4.toString())) {
          var _newValue$value5;

          setValueList(newValue === null || newValue === void 0 ? void 0 : newValue.value);
          setLabelList(newValue === null || newValue === void 0 ? void 0 : newValue.label);
          setCurReqLevel(newValue === null || newValue === void 0 ? void 0 : (_newValue$value5 = newValue.value) === null || _newValue$value5 === void 0 ? void 0 : _newValue$value5.length);
          setOpenReq(true);
        } else {
          setOpenReq(false);
        }
      }, 50);
    }
  };
  /**
   * 列表点击事件
   */


  var listClick = function listClick(val) {
    var newValueList = _toConsumableArray(valueList); // 设置弹框顶部选中label 的值


    var newLabelList = _toConsumableArray(labelList);

    if (lastLevel) {
      newValueList.splice(newValueList.length - 1, 1, val[(alias === null || alias === void 0 ? void 0 : alias.value) || 'value']);
    } else {
      newValueList.push(val[(alias === null || alias === void 0 ? void 0 : alias.value) || 'value']);
    }

    newLabelList.splice(newLabelList.length - 1, 1, val[label]); // 调用 onChangeLevel 让用户修改数据源

    onMChangeLevel(newValueList); // 保存value 值

    setValueList(newValueList);
    setLabelList(newLabelList);
  };
  /**
   * 选中值点击事件
   */


  var labelClick = function labelClick(index) {
    if (index + 1 === labelList.length) return;
    if (index === valueList.length) return;

    var newValueList = _toConsumableArray(valueList).splice(0, index);

    var newLabelList = _toConsumableArray(labelList).splice(0, index);

    setValueList(newValueList);
    setLabelList(newLabelList);
    onMChangeLevel(newValueList);
  };
  /**
   * 输入框点击事件
   */


  var inputClick = function inputClick() {
    if (onClick) onClick();
    if (openReq) onMChangeLevel(valueList, true);

    if (!modalFlag) {
      openMoal();
    }
  };

  var listReverse = []; // eslint-disable-next-line no-plusplus

  for (var i = labelList.length; i < 4; i++) {
    listReverse.push(Math.random().toString(36).substring(7));
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextItem, {
    isVertical: isVertical,
    value: inputLabel,
    placeholder: placeholder,
    disabled: disabled,
    coverStyle: coverStyle,
    className: className,
    labelNumber: labelNumber,
    onClick: inputClick,
    fieldProps: fieldProps,
    arrow: arrow,
    extra: extra
  }, children), /*#__PURE__*/React.createElement(Modal, {
    popup: true,
    visible: modalFlag,
    style: {
      height: height
    },
    onClose: function onClose() {
      return closeModal();
    },
    className: "alitajs-dform-address",
    animationType: "slide-up",
    title: /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-header"
    }, /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-item am-picker-popup-header-left",
      onClick: function onClick() {
        return closeModal();
      }
    }, leftContent), /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-item am-picker-popup-title"
    }, title), /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-item am-picker-popup-header-right",
      onClick: function onClick() {
        onConfirm();
      }
    }, rightContent))
  }, /*#__PURE__*/React.createElement("div", {
    className: "alitajs-dform-address-content"
  }, /*#__PURE__*/React.createElement("div", {
    className: "alitajs-dform-address-value"
  }, _toConsumableArray(labelList).map(function (labelText, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: labelText,
      onClick: function onClick() {
        labelClick(index);
      },
      className: "alitajs-dform-address-label"
    }, /*#__PURE__*/React.createElement("div", {
      className: classnames({
        'alitajs-dform-address-value-item-label': true,
        'alitajs-dform-address-value-select': index + 1 === labelList.length
      })
    }, labelText), index + 1 === labelList.length && /*#__PURE__*/React.createElement("div", {
      className: "alitajs-dform-address-underline"
    }));
  })), list && list.length === 0 && !loading && noData, /*#__PURE__*/React.createElement("div", {
    ref: addressPickerRef,
    id: "alitajs-dform-address-list-id",
    className: "alitajs-dform-address-list",
    style: {
      display: list.length ? '' : 'none'
    }
  }, /*#__PURE__*/React.createElement(List, null, _toConsumableArray(list).map(function (item) {
    return /*#__PURE__*/React.createElement(Item, {
      key: item[(alias === null || alias === void 0 ? void 0 : alias.value) || 'value'],
      onClick: function onClick() {
        listClick(item);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "alitajs-dform-address-list-item"
    }, /*#__PURE__*/React.createElement("div", {
      className: classnames({
        'alitajs-dform-address-list-item-common': true,
        'alitajs-dform-address-list-item-tick': valueList.indexOf(item[(alias === null || alias === void 0 ? void 0 : alias.value) || 'value']) !== -1
      })
    }, item[label]), valueList.indexOf(item[(alias === null || alias === void 0 ? void 0 : alias.value) || 'value']) !== -1 && /*#__PURE__*/React.createElement("div", {
      className: "alitajs-dform-tick"
    })));
  }))))));
};

export default AddressPickerGroup;