function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * title: 基础 选址
 * desc: 表单使用 demo
 */
import React, { useState } from 'react';
import { Button, WhiteSpace, Toast } from 'antd-mobile-v2';
import DynamicForm, { useForm, AddressPicker } from "../../.."; // @ts-ignore

import CountryList from '@bang88/china-city-data';

var Page = function Page() {
  var _useForm = useForm(),
      _useForm2 = _slicedToArray(_useForm, 1),
      form = _useForm2[0];

  var _useState = useState({
    homeAddr: {
      label: ['福建省', '福州市', '鼓楼区'],
      value: ['35', '3501', '350102']
    },
    commonlyAddr: {
      label: ['福建省', '福州市'],
      value: ['35', '3501']
    }
  }),
      _useState2 = _slicedToArray(_useState, 1),
      formsValues = _useState2[0];

  var onFinish = function onFinish(values) {
    // eslint-disable-next-line no-console
    console.log('Success:', values);
  };

  var onFinishFailed = function onFinishFailed(errorInfo) {
    // eslint-disable-next-line no-console
    console.log('Failed:', errorInfo);
  };

  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      homeAddrData = _useState4[0],
      setHomeAddrData = _useState4[1];

  var _useState5 = useState([]),
      _useState6 = _slicedToArray(_useState5, 2),
      commonlyAddrData = _useState6[0],
      setCommonlyAddrData = _useState6[1];

  var _useState7 = useState([]),
      _useState8 = _slicedToArray(_useState7, 2),
      workAddrData = _useState8[0],
      setWorkAddrData = _useState8[1];

  var queryList = function queryList(list, val) {
    var newList = [];
    list.map(function (item) {
      if (item.value === val) {
        newList = item.children;
      }

      if (item.children && Array.isArray(item.children)) {
        var vals = queryList(item.children, val);

        if (vals && vals.length > 0) {
          newList = vals;
        }
      }
    });
    return newList;
  };

  var getResetHomeAddrList = function getResetHomeAddrList(values) {
    var data = [];

    switch (values.length) {
      case 0:
        data = CountryList;
        break;

      case 1:
      case 2:
        data = queryList(CountryList, values[values.length - 1]);
        break;

      case 3:
        break;

      default:
        break;
    }

    return data;
  };

  var getResetWorkAddrList = function getResetWorkAddrList(values) {
    var data = [];

    switch (values.length) {
      case 0:
        data = CountryList;
        break;

      case 1:
      case 2:
        data = queryList(CountryList, values[values.length - 1]);
        break;

      case 3:
        data = [{
          label: '街道1',
          value: 'street1'
        }, {
          label: '街道2',
          value: 'street2'
        }, {
          label: '街道3',
          value: 'street3'
        }, {
          label: '街道4',
          value: 'street4'
        }];
        break;

      default:
        break;
    }

    return data;
  };

  var resetHomeAddrList = function resetHomeAddrList(values, key) {
    var mValues = JSON.parse(JSON.stringify(values));
    var data = getResetHomeAddrList(mValues);
    Toast.hide();

    if (key === 'commonlyAddrData') {
      setCommonlyAddrData(data);
    } else {
      setHomeAddrData(data);
    }
  };

  var resetWorkAddrList = function resetWorkAddrList(values) {
    var mValues = JSON.parse(JSON.stringify(values));
    var data = getResetWorkAddrList(mValues);
    Toast.hide();
    setWorkAddrData(data);
  };

  var formProps = {
    onFinish: onFinish,
    onFinishFailed: onFinishFailed,
    formsValues: formsValues,
    form: form,
    autoLineFeed: false,
    isDev: false
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DynamicForm, formProps, /*#__PURE__*/React.createElement(AddressPicker, {
    fieldProps: "homeAddr",
    title: "\u5DE5\u4F5C\u5730\u5740",
    placeholder: "\u9009\u62E9\u5F53\u524D\u5DE5\u4F5C\u5730\u5740",
    required: true,
    data: homeAddrData,
    placeholderList: ['请选择省', '请选择市', '请选择区'],
    onChangeLevel: function onChangeLevel(values) {
      console.log('values', values);
      Toast.show('加载中'); // eslint-disable-next-line no-console

      setTimeout(function () {
        resetHomeAddrList(values, 'homeAddrData');
      }, 300);
    },
    defaultValue: {
      label: ['福建省', '福州市', '鼓楼区'],
      value: ['35', '3501', '350102']
    },
    onChange: function onChange(value) {
      console.log('onChangevalue', value);
    }
  }), /*#__PURE__*/React.createElement(AddressPicker, {
    fieldProps: "workAddr",
    title: "\u5C45\u4F4F\u5730\u5740",
    placeholder: "\u8BF7\u9009\u62E9",
    positionType: "vertical",
    data: workAddrData,
    placeholderList: ['请选择省', '请选择市', '请选择区', '请选择街道'],
    onChangeLevel: function onChangeLevel(values) {
      Toast.show('加载中');
      setTimeout(function () {
        resetWorkAddrList(values);
        Toast.hide();
      }, 100);
    },
    onChange: function onChange(value) {
      console.log('onChangevalue', value);
    },
    noData: /*#__PURE__*/React.createElement("div", null, "\u6682\u65E0\u8857\u9053\u6570\u636E")
  })), /*#__PURE__*/React.createElement(WhiteSpace, {
    size: "sm"
  }), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: function onClick() {
      return form.setFieldsValue({
        commonlyAddr: {
          label: ['福建省', '福州市', '鼓楼区'],
          value: ['35', '3501', '350102']
        }
      });
    }
  }, "changeValue"), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: function onClick() {
      return form.submit();
    }
  }, "Submit"));
};

export default Page;