function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect, useContext, useMemo } from 'react';
import { CardContext, DformContext } from "../../baseComponents/Context";
import classnames from 'classnames';
import CoverRadioGroup from "./radioGroup";
import Field from "../Field";
import Title from "../../baseComponents/Title";
import HorizontalTitle from "../../baseComponents/HorizontalTitle";
import { allPrefixCls } from "../../const";
import "./index.less";
var prefixCls = 'alitajs-dform-cover-radio';

var CoverRadio = function CoverRadio(props) {
  var _classnames;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      aliasData = _useState2[0],
      setAliasData = _useState2[1];

  var coverStyle = props.coverStyle,
      className = props.className,
      fieldProps = props.fieldProps,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      title = props.title,
      data = props.data,
      onChange = props.onChange,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      _props$radioType = props.radioType,
      radioType = _props$radioType === void 0 ? 'horizontal' : _props$radioType,
      _props$alias = props.alias,
      alias = _props$alias === void 0 ? {
    label: 'label',
    value: 'value'
  } : _props$alias,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      defaultValue = props.defaultValue,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag;

  var _useContext = useContext(CardContext),
      cDisabled = _useContext.cDisabled;

  var _useState3 = useState(disabled || cDisabled),
      _useState4 = _slicedToArray(_useState3, 2),
      mregedDisabled = _useState4[0],
      setMregedDisabled = _useState4[1];

  var _useContext2 = useContext(DformContext),
      changeForm = _useContext2.changeForm;

  var isVertical = positionType === 'vertical';
  var _alias$label = alias.label,
      label = _alias$label === void 0 ? 'label' : _alias$label,
      _alias$value = alias.value,
      value = _alias$value === void 0 ? 'value' : _alias$value;
  useMemo(function () {
    var _changeForm$fieldProp;

    if (cDisabled) return;

    if (((_changeForm$fieldProp = changeForm[fieldProps]) === null || _changeForm$fieldProp === void 0 ? void 0 : _changeForm$fieldProp.disabled) !== undefined) {
      var _changeForm$fieldProp2;

      setMregedDisabled((_changeForm$fieldProp2 = changeForm[fieldProps]) === null || _changeForm$fieldProp2 === void 0 ? void 0 : _changeForm$fieldProp2.disabled);
    } else {
      setMregedDisabled(disabled);
    }
  }, [changeForm[fieldProps], disabled, cDisabled]);
  useEffect(function () {
    var newData = (data || []).map(function (item) {
      return {
        label: item[label],
        value: item[value]
      };
    });
    setAliasData(newData);
  }, [data]);

  if (radioType === 'vertical') {
    isVertical = true;
  }

  var radioChange = function radioChange(e) {
    if (onChange) onChange(e);
  };

  var showFiled = function showFiled() {
    return /*#__PURE__*/React.createElement(CoverRadioGroup, {
      value: defaultValue,
      data: aliasData,
      positionType: positionType,
      radioType: radioType,
      onChange: radioChange,
      disabled: mregedDisabled,
      coverStyle: coverStyle,
      className: className,
      labelNumber: labelNumber
    }, /*#__PURE__*/React.createElement(HorizontalTitle, {
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldProps,
      titleStyle: titleStyle
    }));
  };

  return /*#__PURE__*/React.createElement(Title, {
    independentProps: props,
    type: "coverRadio",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames = {}, _defineProperty(_classnames, prefixCls, true), _defineProperty(_classnames, "".concat(allPrefixCls, "-vertical-radio"), isVertical), _classnames))
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-field")
  }, /*#__PURE__*/React.createElement(Field, {
    title: title,
    required: required,
    name: fieldProps,
    rules: rules,
    initialValue: defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    },
    type: "coverRadio"
  }, showFiled()))));
};

CoverRadio.displayName = 'coverRadio';
export default CoverRadio;