function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * title: 基础 多选框
 * desc: 表单使用 demo
 */
import React from 'react';
import { Button, WhiteSpace } from 'antd-mobile-v2';
import DynamicForm, { useForm, MultiplePicker } from "../../..";

var Page = function Page() {
  var _useForm = useForm(),
      _useForm2 = _slicedToArray(_useForm, 1),
      form = _useForm2[0];

  var onFinish = function onFinish(values) {
    // eslint-disable-next-line no-console
    console.log('Success:', values);
  };

  var onFinishFailed = function onFinishFailed(errorInfo) {
    // eslint-disable-next-line no-console
    console.log('Failed:', errorInfo);
  };

  var foodList = [{
    foodName: '宫保鸡丁',
    foodId: '宫保鸡丁'
  }, {
    foodName: '可乐鸡翅',
    foodId: '可乐鸡翅'
  }, {
    foodName: '爆炒虾仁',
    foodId: '爆炒虾仁'
  }, {
    foodName: '清蒸小黄鱼',
    foodId: '清蒸小黄鱼'
  }, {
    foodName: '红烧肉',
    foodId: '红烧肉'
  }];
  var formsValues = {
    youFood: ['红烧肉', '清蒸小黄鱼']
  };
  var formProps = {
    onFinish: onFinish,
    onFinishFailed: onFinishFailed,
    formsValues: formsValues,
    form: form,
    autoLineFeed: false,
    isDev: false
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DynamicForm, formProps, /*#__PURE__*/React.createElement(MultiplePicker, {
    fieldProps: "food",
    required: true,
    data: foodList,
    title: "\u98DF\u7269(\u9ED8\u8BA4\u503C)",
    labelNumber: 7,
    placeholder: "\u8BF7\u9009\u62E9\u98DF\u7269",
    alias: {
      label: 'foodName',
      value: 'foodId'
    },
    defaultValue: ['爆炒虾仁', '宫保鸡丁'],
    clear: true
  }), /*#__PURE__*/React.createElement(MultiplePicker, {
    fieldProps: "myFood",
    required: true,
    data: foodList,
    title: "\u6211\u559C\u6B22\u7684\u98DF\u7269",
    labelNumber: 7,
    placeholder: "\u8BF7\u9009\u62E9\u6211\u559C\u6B22\u7684\u98DF\u7269",
    alias: {
      label: 'foodName',
      value: 'foodId'
    },
    onChange: function onChange(e) {
      // eslint-disable-next-line no-console
      console.log(e);
    }
  }), /*#__PURE__*/React.createElement(MultiplePicker, {
    fieldProps: "youFood",
    data: foodList,
    title: "\u9009\u62E9\u4F60\u559C\u6B22\u7684\u98DF\u7269(\u4E0D\u53EF\u7F16\u8F91)",
    labelNumber: 7,
    placeholder: "\u8BF7\u9009\u62E9\u6211\u559C\u6B22\u7684\u98DF\u7269",
    positionType: "vertical",
    maxValueLength: 1,
    alias: {
      label: 'foodName',
      value: 'foodId'
    },
    disabled: true
  })), /*#__PURE__*/React.createElement(WhiteSpace, {
    size: "sm"
  }), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: function onClick() {
      return form.submit();
    }
  }, "Submit"));
};

export default Page;