function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect } from 'react';
import { Modal, List } from 'antd-mobile-v2';
import classnames from 'classnames';
import TextItem from "../../baseComponents/TextItem";
import "./index.less";
var Item = List.Item;

var MultiplePickerGroup = function MultiplePickerGroup(props) {
  var _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      title = props.title,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '请选择' : _props$placeholder,
      onChange = props.onChange,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      value = props.value,
      maxValueLength = props.maxValueLength,
      coverStyle = props.coverStyle,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      _onClick = props.onClick,
      _props$leftContent = props.leftContent,
      leftContent = _props$leftContent === void 0 ? '取消' : _props$leftContent,
      _props$rightContent = props.rightContent,
      rightContent = _props$rightContent === void 0 ? '确定' : _props$rightContent,
      height = props.height,
      children = props.children,
      fieldProps = props.fieldProps,
      _props$clear = props.clear,
      clear = _props$clear === void 0 ? false : _props$clear,
      extra = props.extra,
      arrow = props.arrow;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      selValueList = _useState2[0],
      setSelValueList = _useState2[1]; // 当前选中的值列表


  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      modalFlag = _useState4[0],
      setModalFlag = _useState4[1]; // 弹框标识


  var _useState5 = useState(''),
      _useState6 = _slicedToArray(_useState5, 2),
      multipleLabel = _useState6[0],
      setMultipleLabel = _useState6[1]; // 表单上展示的 label 列表


  var isVertical = positionType === 'vertical';
  /**
   * 设值
   * @param da 数据源
   * @param val 值
   */

  var setValues = function setValues(da, val) {
    var filter = da.filter(function (item) {
      return (val === null || val === void 0 ? void 0 : val.indexOf(item.value)) !== -1;
    });
    var labels = filter.map(function (item) {
      return item.label;
    });
    var values = filter.map(function (item) {
      return item.value;
    });
    setMultipleLabel(labels.join(','));
    setSelValueList(values);
    return {
      labels: labels,
      values: values
    };
  };

  useEffect(function () {
    var _setValues = setValues(data, value || []),
        labels = _setValues.labels,
        values = _setValues.values;

    setMultipleLabel(labels.join(','));
    setSelValueList(values);
  }, [value]);
  useEffect(function () {
    var _setValues2 = setValues(data, value || []),
        labels = _setValues2.labels,
        values = _setValues2.values;

    setMultipleLabel(labels.join(','));
    setSelValueList(values);
  }, [data]);

  var pickerClick = function pickerClick(val) {
    var list = JSON.parse(JSON.stringify(selValueList));

    if (list.indexOf(val.value) !== -1) {
      list.splice(list.indexOf(val.value), 1);
    } else {
      list.push(val.value);
    }

    if (maxValueLength && list.length > maxValueLength) {
      list.shift();
    }

    setSelValueList(list);
  };

  var openMoal = function openMoal() {
    if (disabled) return;

    var _setValues3 = setValues(data, value || []),
        labels = _setValues3.labels,
        values = _setValues3.values;

    setMultipleLabel(labels.join(','));
    setSelValueList(values);
    setModalFlag(true);
  };

  var onCancel = function onCancel() {
    setModalFlag(false);
  };

  var onConfirm = function onConfirm() {
    setModalFlag(false);

    var _setValues4 = setValues(data, selValueList || []),
        labels = _setValues4.labels,
        values = _setValues4.values;

    setMultipleLabel(labels.join(','));
    setSelValueList(values);
    onChange === null || onChange === void 0 ? void 0 : onChange(values);
  };
  /**
   * 清理按钮点击事件
   */


  var clearClick = function clearClick() {
    onChange === null || onChange === void 0 ? void 0 : onChange(undefined);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextItem, {
    fieldProps: fieldProps,
    isVertical: isVertical,
    value: multipleLabel,
    disabled: disabled,
    placeholder: placeholder,
    labelNumber: labelNumber,
    coverStyle: coverStyle,
    className: className,
    onClick: function onClick() {
      if (_onClick) _onClick();
      openMoal();
    },
    arrow: arrow,
    clear: clear,
    clearClick: clearClick,
    extra: extra,
    ellipsis: false
  }, children), /*#__PURE__*/React.createElement(Modal, {
    popup: true,
    visible: modalFlag,
    onClose: function onClose() {
      onCancel();
    },
    style: {
      height: height
    },
    className: "alitajs-dform-multiple-picker",
    animationType: "slide-up",
    title: /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-header"
    }, /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-item am-picker-popup-header-left",
      onClick: function onClick() {
        onCancel();
      }
    }, leftContent), /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-item am-picker-popup-title"
    }, title), /*#__PURE__*/React.createElement("div", {
      className: "am-picker-popup-item am-picker-popup-header-right",
      onClick: function onClick() {
        onConfirm();
      }
    }, rightContent))
  }, /*#__PURE__*/React.createElement(List, {
    className: "alitajs-dform-modal-content"
  }, data.map(function (item) {
    return /*#__PURE__*/React.createElement(Item, {
      key: item.value
    }, /*#__PURE__*/React.createElement("div", {
      className: "alitajs-dform-multiple-picker-item",
      onClick: function onClick() {
        pickerClick(item);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: classnames({
        'alitajs-dform-multiple-picker-label': true,
        'alitajs-dform-multiple-picker-checked': selValueList.indexOf(item === null || item === void 0 ? void 0 : item.value) !== -1
      })
    }, item.label), selValueList.indexOf(item === null || item === void 0 ? void 0 : item.value) !== -1 && /*#__PURE__*/React.createElement("div", {
      className: "alitajs-dform-tick"
    })));
  })), /*#__PURE__*/React.createElement("div", {
    style: {
      height: '1.2rem'
    }
  })));
};

export default MultiplePickerGroup;