function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useEffect } from 'react';
import classnames from 'classnames';
import Field from "../Field";
import Title from "../../baseComponents/Title";
import CustomGroup from "./CustomGroup";
import HorizontalTitle from "../../baseComponents/HorizontalTitle";
import { allPrefixCls } from "../../const";
import "./index.less";

var DformCustom = function DformCustom(props) {
  var defaultValue = props.defaultValue,
      fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      title = props.title,
      CustomDom = props.CustomDom,
      customDomProps = props.customDomProps,
      children = props.children,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'vertical' : _props$positionType,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      onChange = props.onChange,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden;
  var isVertical = positionType === 'vertical';
  var fieldKey = fieldName || fieldProps;
  useEffect(function () {
    if (CustomDom || customDomProps) {
      console.warn('DformCustom组件已放弃CustomDom、customDomProps属性，请切换为children');
    }
  }, [CustomDom, customDomProps]);

  var cutomTitle = function cutomTitle() {
    return /*#__PURE__*/React.createElement(HorizontalTitle, {
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldKey,
      titleStyle: titleStyle
    });
  };

  var fieldChange = function fieldChange(e) {
    if (onChange) onChange(e);
  };

  return /*#__PURE__*/React.createElement(Title, {
    independentProps: props,
    type: "custom",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames(_defineProperty({}, "".concat(allPrefixCls, "-dom"), true))
  }, !isVertical && cutomTitle(), /*#__PURE__*/React.createElement(Field, {
    name: fieldKey,
    title: title,
    required: required,
    rules: rules,
    initialValue: defaultValue,
    type: "custom",
    params: {
      hidden: hidden,
      formFlag: formFlag
    }
  }, /*#__PURE__*/React.createElement(CustomGroup, {
    isVertical: isVertical,
    CustomDom: CustomDom,
    customDomProps: customDomProps,
    cutomTitle: cutomTitle(),
    onChange: fieldChange,
    children: children
  }))));
};

DformCustom.displayName = 'dformCustom';
export default DformCustom;