var _excluded = ["positionType", "onChange", "modeType", "minDate", "maxDate", "use12Hours", "minuteStep", "placeholder", "labelNumber", "coverStyle", "disabled", "extra", "className", "format", "onValueChange", "arrow", "children", "fieldProps", "value", "replaceName"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect } from 'react';
import PopupDatePicker from 'rmc-date-picker/lib/Popup';
import RCDatePicker from 'rmc-date-picker/lib/DatePicker';
import DatePickerLocale from 'rmc-date-picker/lib/locale/zh_CN';
import { changeDateFormat, dateNameReplace } from "../../utils";
import TextItem from "../../baseComponents/TextItem";

var DatePickerGroup = function DatePickerGroup(props) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useState3 = useState(''),
      _useState4 = _slicedToArray(_useState3, 2),
      textValue = _useState4[0],
      setTextValue = _useState4[1];

  var _useState5 = useState(undefined),
      _useState6 = _slicedToArray(_useState5, 2),
      dateValue = _useState6[0],
      setDateValue = _useState6[1];

  var _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? '' : _props$positionType,
      onChange = props.onChange,
      _props$modeType = props.modeType,
      modeType = _props$modeType === void 0 ? 'date' : _props$modeType,
      minDate = props.minDate,
      maxDate = props.maxDate,
      _props$use12Hours = props.use12Hours,
      use12Hours = _props$use12Hours === void 0 ? false : _props$use12Hours,
      _props$minuteStep = props.minuteStep,
      minuteStep = _props$minuteStep === void 0 ? 1 : _props$minuteStep,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '请选择' : _props$placeholder,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      coverStyle = props.coverStyle,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$extra = props.extra,
      extra = _props$extra === void 0 ? '' : _props$extra,
      className = props.className,
      format = props.format,
      onValueChange = props.onValueChange,
      arrow = props.arrow,
      children = props.children,
      fieldProps = props.fieldProps,
      value = props.value,
      replaceName = props.replaceName,
      otherProps = _objectWithoutProperties(props, _excluded);

  useEffect(function () {
    if (value) {
      setTextValue(changeDateFormat({
        value: value,
        modeType: modeType,
        format: format,
        replaceName: replaceName
      }));
      setDateValue(new Date(dateNameReplace({
        value: value,
        replaceName: replaceName
      }) || ''));
    } else {
      setTextValue('');
      setDateValue(undefined);
    }
  }, [value]);
  var isVertical = positionType === 'vertical';
  var datePicker = /*#__PURE__*/React.createElement(RCDatePicker, {
    locale: DatePickerLocale,
    minuteStep: minuteStep,
    minDate: minDate,
    maxDate: maxDate,
    mode: modeType,
    pickerPrefixCls: "am-picker-col",
    prefixCls: "am-picker",
    defaultDate: value || new Date(),
    use12Hours: use12Hours,
    onValueChange: onValueChange,
    onScrollChange: function onScrollChange() {}
  });
  /**
   * date 改变事件
   */

  var dateChange = function dateChange(e) {
    setTextValue(changeDateFormat({
      value: e,
      modeType: modeType,
      format: format
    }));
    if (onChange) onChange(e);
    setVisible(false);
  };

  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(PopupDatePicker, _extends({
    datePicker: datePicker,
    WrapComponent: "div",
    transitionName: "am-slide-up",
    maskTransitionName: "am-fade",
    prefixCls: "am-picker-popup",
    title: "\u9009\u62E9\u65E5\u671F",
    date: dateValue || new Date(),
    okText: "\u786E\u8BA4",
    dismissText: "\u53D6\u6D88",
    onDismiss: function onDismiss() {
      return setVisible(false);
    },
    onChange: dateChange,
    visible: visible,
    onVisibleChange: function onVisibleChange() {
      setVisible(false);
    }
  }, otherProps)), /*#__PURE__*/React.createElement(TextItem, {
    fieldProps: fieldProps,
    isVertical: isVertical,
    placeholder: placeholder,
    labelNumber: labelNumber,
    coverStyle: coverStyle,
    value: textValue,
    disabled: disabled,
    extra: extra,
    className: className,
    onClick: function onClick() {
      setVisible(true);
    },
    arrow: arrow,
    ellipsis: true
  }, children));
};

export default DatePickerGroup;