function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useContext, useMemo } from 'react';
import { CardContext, DformContext } from "../../baseComponents/Context";
import Field from "../Field";
import Title from "../../baseComponents/Title";
import FileGroup from "./fileGroup";
// @ts-ignore
import FileIcon from "../../assets/file.png";
var prefixCls = 'alitajs-dform-file';

var DformFile = function DformFile(props) {
  var fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      title = props.title,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      _props$extra = props.extra,
      extra = _props$extra === void 0 ? /*#__PURE__*/React.createElement("img", {
    src: FileIcon,
    alt: "",
    className: "".concat(prefixCls, "-img")
  }) : _props$extra,
      uploadExtra = props.uploadExtra,
      onChange = props.onChange,
      defaultValue = props.defaultValue,
      upload = props.upload,
      fileProps = props.fileProps,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      maxLength = props.maxLength,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      valueStyle = props.valueStyle,
      itemExtra = props.itemExtra;

  var _useContext = useContext(CardContext),
      cDisabled = _useContext.cDisabled;

  var _useState = useState(disabled || cDisabled),
      _useState2 = _slicedToArray(_useState, 2),
      mregedDisabled = _useState2[0],
      setMregedDisabled = _useState2[1];

  var _useContext2 = useContext(DformContext),
      changeForm = _useContext2.changeForm;

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      selectable = _useState4[0],
      setSelectable = _useState4[1];

  var fieldKey = fieldName || fieldProps;
  useMemo(function () {
    var _changeForm$fieldKey;

    if (cDisabled) return;

    if (((_changeForm$fieldKey = changeForm[fieldKey]) === null || _changeForm$fieldKey === void 0 ? void 0 : _changeForm$fieldKey.disabled) !== undefined) {
      var _changeForm$fieldKey2;

      setMregedDisabled((_changeForm$fieldKey2 = changeForm[fieldKey]) === null || _changeForm$fieldKey2 === void 0 ? void 0 : _changeForm$fieldKey2.disabled);
    } else {
      setMregedDisabled(disabled);
    }
  }, [changeForm[fieldKey], disabled, cDisabled]); // 该函数没被使用，因此注释

  var fileIns = function fileIns(e) {
    if (e.target.files) {
      var fileList = Object.keys(e.target.files).map(function (item) {
        return e.target.files[item];
      });
      upload(fileList);
      e.target.value = "";
    }
  };

  var extraContent = function extraContent() {
    return uploadExtra ? /*#__PURE__*/React.createElement("div", {
      className: "alitajs-dform-file-input"
    }, uploadExtra) : /*#__PURE__*/React.createElement(React.Fragment, null, !mregedDisabled && selectable && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", _extends({
      type: "file",
      multiple: true,
      className: "alitajs-dform-file-input",
      onChange: fileIns
    }, fileProps, {
      "aria-labelledby": fieldKey,
      "aria-label": fieldKey
    }))), /*#__PURE__*/React.createElement("span", {
      className: "alitajs-dform-file-extra"
    }, extra)));
  };

  var fileChange = function fileChange(res, item, type) {
    if (onChange) onChange(res, item, type);
  };

  var valueChange = function valueChange(e) {
    if (!!maxLength && maxLength <= e.length) {
      setSelectable(false);
    } else {
      setSelectable(true);
    }
  };

  return /*#__PURE__*/React.createElement(Title, {
    type: "file",
    independentProps: _objectSpread(_objectSpread({
      positionType: 'vertical'
    }, props), {}, {
      extra: extraContent()
    }),
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement(Field, {
    type: "file",
    title: title,
    required: required,
    rules: rules,
    name: fieldKey,
    initialValue: defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    }
  }, /*#__PURE__*/React.createElement(FileGroup, _extends({
    value: defaultValue
  }, props, {
    disabled: mregedDisabled,
    onChange: fileChange,
    valueChange: valueChange,
    valueStyle: valueStyle,
    itemExtra: itemExtra
  })))));
};

DformFile.displayName = 'dformFile';
export default DformFile;