var _excluded = ["onChange", "limitSize", "compressRatio", "value", "maxLength", "disabled"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect } from 'react';
import { ImagePicker, Toast } from 'antd-mobile-v2';
import { transformFile } from "../../utils";

var ImagePickerGroup = function ImagePickerGroup(props) {
  var onChange = props.onChange,
      limitSize = props.limitSize,
      compressRatio = props.compressRatio,
      _props$value = props.value,
      value = _props$value === void 0 ? [] : _props$value,
      maxLength = props.maxLength,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      selectable = _useState2[0],
      setSelectable = _useState2[1];

  useEffect(function () {
    if (disabled) {
      setSelectable(false);
      return;
    }

    if (maxLength && value && value.length && value.length >= maxLength) {
      setSelectable(false);
    } else {
      setSelectable(true);
    }
  }, [disabled, JSON.stringify(value || [])]);

  var checkFileLimit = function checkFileLimit(file) {
    if (limitSize && file && file.size && file.size > limitSize) {
      Toast.fail('图片过大', 1);
      return false;
    }

    return true;
  };

  var imageChange = function imageChange(files, operationType, index) {
    if (files && files.length > value.length) {
      var lastFile = files[files.length - 1];
      var _lastFile$file = lastFile.file,
          file = _lastFile$file === void 0 ? {} : _lastFile$file;

      if (compressRatio && lastFile.url.indexOf('base64,') !== -1) {
        transformFile(lastFile.file, compressRatio).then(function (newFile) {
          var reader = new FileReader();
          reader.readAsDataURL(newFile);

          reader.onload = function (_ref) {
            var target = _ref.target;
            if (!checkFileLimit(newFile)) return;
            files[files.length - 1] = _objectSpread(_objectSpread({}, files[files.length - 1]), {}, {
              file: newFile,
              url: (target === null || target === void 0 ? void 0 : target.result) || ''
            });
          };
        });
      } else if (!checkFileLimit(file)) return;
    }

    onChange(files, operationType, index);
  };

  return /*#__PURE__*/React.createElement(ImagePicker, _extends({
    selectable: selectable
  }, otherProps, {
    onChange: imageChange,
    files: value
  }));
};

export default ImagePickerGroup;