var _excluded = ["inputType", "coverStyle", "title", "required", "fieldProps", "fieldName", "rules", "positionType", "hasStar", "extra", "subTitle", "hidden", "onBlur", "editable", "className", "disabled", "defaultValue", "placeholder", "maxLine", "onClick", "labelNumber", "boxStyle", "titleStyle", "formFlag"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useContext, useMemo } from 'react';
import { CardContext, DformContext } from "../../baseComponents/Context";
import InputItem from "../../baseComponents/InputItem";
import Field from "../Field";
import Title from "../../baseComponents/Title";
import HorizontalTitle from "../../baseComponents/HorizontalTitle";
import TextItem from "../../baseComponents/TextItem";

var DformInput = function DformInput(props) {
  var _props$inputType = props.inputType,
      inputType = _props$inputType === void 0 ? 'text' : _props$inputType,
      coverStyle = props.coverStyle,
      _props$title = props.title,
      title = _props$title === void 0 ? '' : _props$title,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      extra = props.extra,
      subTitle = props.subTitle,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      onBlur = props.onBlur,
      _props$editable = props.editable,
      editable = _props$editable === void 0 ? true : _props$editable,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      defaultValue = props.defaultValue,
      placeholder = props.placeholder,
      maxLine = props.maxLine,
      onClick = props.onClick,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useContext = useContext(CardContext),
      cDisabled = _useContext.cDisabled;

  var _useState = useState(disabled || cDisabled),
      _useState2 = _slicedToArray(_useState, 2),
      mregedDisabled = _useState2[0],
      setMregedDisabled = _useState2[1];

  var _useContext2 = useContext(DformContext),
      changeForm = _useContext2.changeForm;

  var fieldKey = fieldName || fieldProps;
  var isVertical = positionType === 'vertical';
  useMemo(function () {
    var _changeForm$fieldKey;

    if (cDisabled) return;

    if (((_changeForm$fieldKey = changeForm[fieldKey]) === null || _changeForm$fieldKey === void 0 ? void 0 : _changeForm$fieldKey.disabled) !== undefined) {
      var _changeForm$fieldKey2;

      setMregedDisabled((_changeForm$fieldKey2 = changeForm[fieldKey]) === null || _changeForm$fieldKey2 === void 0 ? void 0 : _changeForm$fieldKey2.disabled);
    } else {
      setMregedDisabled(disabled);
    }
  }, [changeForm[fieldKey], disabled, cDisabled]);

  var inputOnBlur = function inputOnBlur(val) {
    if (onBlur) onBlur(val);
  };

  var showTextFiled = function showTextFiled() {
    return /*#__PURE__*/React.createElement(TextItem, {
      value: defaultValue,
      placeholder: placeholder,
      extra: extra,
      coverStyle: _objectSpread({
        color: '#999'
      }, coverStyle),
      isVertical: isVertical,
      labelNumber: labelNumber // @ts-ignore
      ,
      onClick: onClick,
      disabled: mregedDisabled,
      maxLine: maxLine,
      fieldProps: fieldKey,
      className: className,
      ellipsis: false,
      arrow: false
    }, /*#__PURE__*/React.createElement(HorizontalTitle, {
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldKey,
      titleStyle: titleStyle
    }));
  };

  var showFiled = function showFiled() {
    return /*#__PURE__*/React.createElement(InputItem, _extends({
      value: defaultValue
    }, otherProps, {
      labelNumber: labelNumber > 7 ? 7 : labelNumber,
      onClick: onClick,
      placeholder: placeholder,
      fieldProps: fieldKey,
      extra: isVertical ? '' : extra,
      type: inputType,
      editable: editable,
      disabled: mregedDisabled,
      className: className,
      coverStyle: _objectSpread({
        textAlign: isVertical ? 'left' : 'right'
      }, coverStyle),
      onBlur: function onBlur(val) {
        inputOnBlur(val);
      },
      isVertical: isVertical
    }), /*#__PURE__*/React.createElement(HorizontalTitle, {
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldKey,
      titleStyle: titleStyle
    }));
  };

  return /*#__PURE__*/React.createElement(Title, {
    independentProps: props,
    type: "input",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/React.createElement(Field, {
    name: fieldKey,
    rules: rules,
    title: title,
    required: required,
    initialValue: defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    },
    type: "input"
  }, editable && !mregedDisabled ? showFiled() : showTextFiled()));
};

DformInput.displayName = 'dformInput';
export default DformInput;