function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect } from 'react';
import { Picker, Toast } from 'antd-mobile-v2';
import TextItem from "../../baseComponents/TextItem";

var NomarPickerGroup = function NomarPickerGroup(props) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setvisible = _useState2[1];

  var _useState3 = useState(''),
      _useState4 = _slicedToArray(_useState3, 2),
      pickerLabel = _useState4[0],
      setPickerLabel = _useState4[1];

  var fieldProps = props.fieldProps,
      children = props.children,
      _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      title = props.title,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '请选择' : _props$placeholder,
      onChange = props.onChange,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      coverStyle = props.coverStyle,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      _props$extra = props.extra,
      extra = _props$extra === void 0 ? '' : _props$extra,
      className = props.className,
      onClick = props.onClick,
      value = props.value,
      arrow = props.arrow,
      _props$clear = props.clear,
      clear = _props$clear === void 0 ? false : _props$clear,
      customTitle = props.customTitle,
      _props$insistOpenModa = props.insistOpenModal,
      insistOpenModal = _props$insistOpenModa === void 0 ? false : _props$insistOpenModa;
  var isVertical = positionType === 'vertical';
  useEffect(function () {
    if (data.length === 0) {
      setPickerLabel('');
      return;
    }

    var filterList = data.filter(function (item) {
      return (item === null || item === void 0 ? void 0 : item.value) === value;
    });

    if (filterList && filterList.length) {
      setPickerLabel(filterList[0].label);
    } else {
      setPickerLabel('');
    }
  }, [value]);
  useEffect(function () {
    if (data && data.length) {
      var nowValue = value;
      var filterList = data.filter(function (item) {
        return (item === null || item === void 0 ? void 0 : item.value) === nowValue;
      });

      if (filterList && filterList.length) {
        setPickerLabel(filterList[0].label);
      } else {
        setPickerLabel('');
      }
    } else {
      setPickerLabel('');
    }
  }, [data]);

  var fieldClick = function fieldClick() {
    if (disabled) return;

    if (!insistOpenModal) {
      if (!!!data.length && !!onClick) {
        onClick(value);
        return;
      } else if (!!!data.length) {
        Toast.fail('数据未配置');
        return;
      }
    }

    if (!!onClick) {
      onClick(value);
    }

    setvisible(true);
  };

  var onOK = function onOK(val) {
    setvisible(false);
    onChange(val[0]);
  };
  /**
   * 清理按钮点击事件
   */


  var clearClick = function clearClick() {
    onChange(undefined);
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TextItem, {
    isVertical: isVertical,
    value: "".concat(pickerLabel),
    placeholder: placeholder,
    labelNumber: labelNumber,
    coverStyle: coverStyle,
    onClick: fieldClick,
    disabled: disabled,
    extra: extra,
    className: className,
    fieldProps: fieldProps,
    arrow: arrow,
    clear: clear,
    clearClick: clearClick
  }, children), /*#__PURE__*/React.createElement(Picker
  /** @ts-ignore */
  , {
    title: customTitle || title,
    visible: visible && data.length > 0 && !insistOpenModal || visible && insistOpenModal,
    data: data,
    cols: 1,
    value: value ? [value] : undefined,
    onOk: onOK,
    onDismiss: function onDismiss() {
      setvisible(false);
    },
    onVisibleChange: function onVisibleChange() {
      setvisible(false);
    }
  }));
};

export default NomarPickerGroup;