function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * title: 基础 单选框
 * desc: 表单使用 demo
 */
import React from 'react';
import { Button, WhiteSpace } from 'antd-mobile-v2';
import DynamicForm, { useForm, DformPicker } from "../../..";

var Page = function Page() {
  var _useForm = useForm(),
      _useForm2 = _slicedToArray(_useForm, 1),
      form = _useForm2[0];

  var onFinish = function onFinish(values) {
    // eslint-disable-next-line no-console
    console.log('Success:', values);
  };

  var onFinishFailed = function onFinishFailed(errorInfo) {
    // eslint-disable-next-line no-console
    console.log('Failed:', errorInfo);
  };

  var aliasCityList = [{
    cityId: '深圳',
    cityName: 'shenzhen'
  }, {
    cityId: '杭州',
    cityName: 'hangzhou'
  }, {
    cityId: '广州',
    cityName: 'guangzhou'
  }];
  var cityList = [{
    label: '北京',
    value: 'beijing'
  }, {
    label: '上海',
    value: 'shanghai'
  }, {
    label: '福州',
    value: 'fuzhou'
  }];
  var formsValues = {
    youCity: 'fuzhou'
  };
  var formProps = {
    onFinish: onFinish,
    onFinishFailed: onFinishFailed,
    formsValues: formsValues,
    form: form,
    autoLineFeed: false,
    isDev: false
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DynamicForm, formProps, /*#__PURE__*/React.createElement(DformPicker, {
    fieldProps: "city",
    data: cityList,
    title: "\u57CE\u5E02(\u9ED8\u8BA4\u503C)",
    labelNumber: 6,
    defaultValue: "shanghai",
    clear: true
  }), /*#__PURE__*/React.createElement(DformPicker, {
    fieldProps: "myCity",
    required: true,
    data: aliasCityList,
    title: "\u6211\u559C\u6B22\u7684\u57CE\u5E02",
    labelNumber: 7,
    placeholder: "\u8BF7\u9009\u62E9\u6211\u559C\u6B22\u7684\u57CE\u5E02",
    alias: {
      label: 'cityId',
      value: 'cityName'
    },
    clear: true
  }), /*#__PURE__*/React.createElement(DformPicker, {
    fieldProps: "myCity2",
    data: [],
    title: "\u6211\u5C45\u4F4F\u8FC7\u7684\u57CE\u5E02(\u6CA1\u6570\u636E)",
    positionType: "vertical",
    labelNumber: 6
  }), /*#__PURE__*/React.createElement(DformPicker, {
    fieldProps: "youCity",
    data: cityList,
    title: "\u9009\u62E9\u4F60\u559C\u6B22\u7684\u57CE\u5E02",
    positionType: "vertical",
    onChange: function onChange(e) {
      return console.log(e);
    },
    disabled: true
  })), /*#__PURE__*/React.createElement(WhiteSpace, {
    size: "sm"
  }), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: function onClick() {
      return form.submit();
    }
  }, "Submit"));
};

export default Page;