function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo, useState, useContext } from 'react';
import { CardContext, DformContext } from "../../baseComponents/Context";
import HorizontalTitle from "../../baseComponents/HorizontalTitle";
import Field from "../Field";
import Title from "../../baseComponents/Title";
import "./index.less";
import SelectGroup from "./NomarSelectGroup";
import { is2Dimensionals } from "./utils";

var DformSelect = function DformSelect(props) {
  var title = props.title,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      _props$data = props.data,
      data = _props$data === void 0 ? [] : _props$data,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      onChange = props.onChange,
      _props$alias = props.alias,
      alias = _props$alias === void 0 ? {
    label: 'label',
    value: 'value'
  } : _props$alias,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      defaultValue = props.defaultValue,
      maxLine = props.maxLine,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled;
  var isVertical = positionType === 'vertical';
  var _alias$label = alias.label,
      label = _alias$label === void 0 ? 'label' : _alias$label,
      _alias$value = alias.value,
      value = _alias$value === void 0 ? 'value' : _alias$value;

  var _React$useState = React.useState(),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      initValue = _React$useState2[0],
      setInitValue = _React$useState2[1];

  var _useContext = useContext(CardContext),
      cDisabled = _useContext.cDisabled;

  var _useState = useState(disabled || cDisabled),
      _useState2 = _slicedToArray(_useState, 2),
      mregedDisabled = _useState2[0],
      setMregedDisabled = _useState2[1];

  var _useContext2 = useContext(DformContext),
      changeForm = _useContext2.changeForm;

  var fieldKey = fieldName || fieldProps;
  useMemo(function () {
    var _changeForm$fieldKey;

    if (cDisabled) return;

    if (((_changeForm$fieldKey = changeForm[fieldKey]) === null || _changeForm$fieldKey === void 0 ? void 0 : _changeForm$fieldKey.disabled) !== undefined) {
      var _changeForm$fieldKey2;

      setMregedDisabled((_changeForm$fieldKey2 = changeForm[fieldKey]) === null || _changeForm$fieldKey2 === void 0 ? void 0 : _changeForm$fieldKey2.disabled);
    } else {
      setMregedDisabled(disabled);
    }
  }, [changeForm[fieldKey], disabled, cDisabled]);

  var twoDimensionalTransform = function twoDimensionalTransform() {
    var newAllArray = [];

    for (var i = 0; i < data.length; i++) {
      var newData = data[i].map(function (item) {
        return {
          label: item[label],
          value: item[value]
        };
      });
      newAllArray.push(newData);
    }

    return newAllArray;
  };

  var cascadeTransform = function cascadeTransform() {
    var cascadeTransformItem = function cascadeTransformItem(originData) {
      return (originData || []).map(function (origin) {
        var _ref = origin || {},
            children = _ref.children;

        return {
          label: origin[label],
          value: origin[value],
          children: cascadeTransformItem(children)
        };
      });
    };

    return cascadeTransformItem(data);
  };

  var aliasData = useMemo(function () {
    if (is2Dimensionals(data)) {
      return twoDimensionalTransform();
    }

    return cascadeTransform();
  }, [data, label, value]);

  var fieldChange = function fieldChange(values, flag) {
    if (flag === 'init') return;
    if (onChange && values !== initValue) onChange(values);
  };

  return /*#__PURE__*/React.createElement(Title, {
    independentProps: props,
    type: "select",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/React.createElement(Field, {
    title: title,
    required: required,
    rules: rules,
    name: fieldKey,
    initialValue: defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    },
    type: "select"
  }, /*#__PURE__*/React.createElement(SelectGroup, _extends({}, props, {
    disabled: mregedDisabled,
    value: initValue || defaultValue,
    onChange: fieldChange,
    data: aliasData,
    maxLine: maxLine,
    fieldProps: fieldKey
  }), /*#__PURE__*/React.createElement(HorizontalTitle, {
    required: required,
    hasStar: hasStar,
    title: title,
    labelNumber: labelNumber,
    isVertical: isVertical,
    fieldProps: fieldKey,
    titleStyle: titleStyle
  }))));
};

DformSelect.displayName = 'dformSelect';
export default DformSelect;