var _excluded = ["fieldProps", "fieldProps2", "placeholder", "placeholder2", "required", "rules", "title", "minDate", "maxDate", "modeType", "positionType", "hasStar", "secondProps", "firstProps", "subTitle", "hidden", "labelNumber", "boxStyle", "titleStyle", "coverStyle", "formFlag"];

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import classnames from 'classnames';
import Field from "../Field";
import Title from "../../baseComponents/Title";
import HorizontalTitle from "../../baseComponents/HorizontalTitle";
import { changeDateFormat } from "../../utils";
import DatePickerGroup from "../NomarDatePicker/DatePickerGroup";
import { allPrefixCls } from "../../const/index";
import "./index.less";

var RangeDatePicker = function RangeDatePicker(props) {
  var _classnames;

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      beginDate = _useState2[0],
      setBeginDate = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      endDate = _useState4[0],
      setEndDate = _useState4[1];

  var fieldProps = props.fieldProps,
      fieldProps2 = props.fieldProps2,
      _props$placeholder = props.placeholder,
      placeholder = _props$placeholder === void 0 ? '开始时间' : _props$placeholder,
      _props$placeholder2 = props.placeholder2,
      placeholder2 = _props$placeholder2 === void 0 ? '结束时间' : _props$placeholder2,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      title = props.title,
      minDate = props.minDate,
      maxDate = props.maxDate,
      _props$modeType = props.modeType,
      modeType = _props$modeType === void 0 ? 'date' : _props$modeType,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'vertical' : _props$positionType,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      secondProps = props.secondProps,
      firstProps = props.firstProps,
      subTitle = props.subTitle,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$coverStyle = props.coverStyle,
      coverStyle = _props$coverStyle === void 0 ? {} : _props$coverStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      otherProps = _objectWithoutProperties(props, _excluded);

  var isVertical = positionType === 'vertical';
  return /*#__PURE__*/React.createElement(Title, {
    independentProps: _objectSpread({
      positionType: positionType
    }, props),
    type: "rangeDatePicker",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames((_classnames = {}, _defineProperty(_classnames, "".concat(allPrefixCls, "-range-horizontal"), !isVertical), _defineProperty(_classnames, "".concat(allPrefixCls, "-range-date-picker"), true), _classnames)),
    style: {
      justifyContent: isVertical ? 'space-between' : 'center',
      width: isVertical ? '' : '100%'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-begin").concat(isVertical ? '-vertical' : '', "-picker")
  }, /*#__PURE__*/React.createElement(Field, {
    type: "rangeDatePicker",
    title: title,
    required: required,
    rules: rules,
    name: fieldProps,
    shouldUpdate: function shouldUpdate(prevValue, nextValue) {
      setBeginDate(nextValue && nextValue[fieldProps]);
      return prevValue !== nextValue;
    },
    initialValue: firstProps === null || firstProps === void 0 ? void 0 : firstProps.defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    }
  }, /*#__PURE__*/React.createElement(DatePickerGroup, _extends({}, otherProps, firstProps, {
    value: firstProps === null || firstProps === void 0 ? void 0 : firstProps.defaultValue,
    onChange: function onChange(e) {
      setBeginDate(e);
      (firstProps === null || firstProps === void 0 ? void 0 : firstProps.onChange) && (firstProps === null || firstProps === void 0 ? void 0 : firstProps.onChange(e));
    },
    fieldProps: fieldProps,
    title: title,
    labelNumber: isVertical ? 0 : labelNumber,
    coverStyle: _objectSpread({
      textAlign: 'center'
    }, coverStyle),
    arrow: false,
    minDate: minDate,
    maxDate: endDate || maxDate,
    mode: modeType,
    format: function format(value) {
      return changeDateFormat({
        value: value,
        modeType: modeType
      });
    }
  }), !isVertical && /*#__PURE__*/React.createElement(HorizontalTitle, {
    required: required,
    hasStar: hasStar,
    title: title,
    labelNumber: labelNumber,
    isVertical: isVertical,
    fieldProps: fieldProps,
    titleStyle: titleStyle
  })))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-line")
  }, "~"), /*#__PURE__*/React.createElement("div", {
    className: "".concat(allPrefixCls, "-end").concat(isVertical ? '-vertical' : '', "-picker")
  }, /*#__PURE__*/React.createElement(Field, {
    name: fieldProps2,
    rules: [].concat(_toConsumableArray(rules || []), [{
      required: required,
      message: "\u8BF7\u9009\u62E9".concat(title)
    }]),
    shouldUpdate: function shouldUpdate(prevValue, nextValue) {
      setEndDate(nextValue && nextValue[fieldProps2]);
      return prevValue !== nextValue;
    },
    initialValue: secondProps === null || secondProps === void 0 ? void 0 : secondProps.defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    }
  }, /*#__PURE__*/React.createElement(DatePickerGroup, _extends({}, otherProps, secondProps, {
    value: secondProps === null || secondProps === void 0 ? void 0 : secondProps.defaultValue,
    onChange: function onChange(e) {
      setEndDate(e);
      secondProps && (secondProps === null || secondProps === void 0 ? void 0 : secondProps.onChange) && (secondProps === null || secondProps === void 0 ? void 0 : secondProps.onChange(e));
    },
    fieldProps: fieldProps2,
    title: title,
    labelNumber: 0,
    coverStyle: _objectSpread({
      textAlign: 'center'
    }, coverStyle),
    mode: modeType,
    format: function format(value) {
      return changeDateFormat({
        value: value,
        modeType: modeType
      });
    },
    minDate: beginDate || minDate,
    maxDate: maxDate
  }))))));
};

RangeDatePicker.displayName = 'rangeDatePicker';
export default RangeDatePicker;