function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect } from 'react';
import { WhiteSpace, Button } from 'antd-mobile-v2';
import DynamicForm, { useForm } from "./..";
var sexData = [{
  label: '男',
  value: 'man'
}, {
  label: '女',
  value: 'woman'
}];
var weatherData = [{
  label: '晴',
  value: '晴'
}, {
  label: '阴',
  value: '阴'
}, {
  label: '雨',
  value: '雨'
}];
var motionData = [{
  label: '篮球',
  value: '篮球'
}, {
  label: '羽毛球',
  value: '羽毛球'
}, {
  label: '乒乓球',
  value: '乒乓球'
}];
var fruitData = [{
  label: '哈密瓜',
  value: '哈密瓜'
}, {
  label: '菠萝',
  value: '菠萝'
}, {
  label: '香梨',
  value: '香梨'
}];
var data = [{
  type: 'group',
  fieldProps: 'group1',
  groupProps: {
    type: 'card',
    title: '卡片一',
    required: true
  },
  children: [{
    type: 'input',
    fieldProps: 'username',
    required: true,
    placeholder: '请输入',
    title: '用户名',
    defaultValue: '小红'
  }, {
    type: 'group',
    fieldProps: 'group2',
    groupProps: {
      type: 'card',
      title: '卡片二',
      required: true
    },
    children: [{
      type: 'radio',
      fieldProps: 'sex',
      title: '性别',
      data: sexData,
      required: true
    }]
  }]
}, {
  type: 'group',
  fieldProps: 'group3',
  groupProps: {
    type: 'card',
    title: '卡片三',
    required: true,
    leftView: /*#__PURE__*/React.createElement("div", {
      style: {
        background: '#1890ff',
        margin: '0.1rem 0.1rem 0 0',
        width: '0.1rem',
        height: '0.3rem',
        borderRadius: '0.4rem'
      }
    })
  },
  children: [{
    type: 'picker',
    fieldProps: 'weather',
    placeholder: '请选择',
    title: '天气',
    data: weatherData
  }, {
    type: 'rangeDatePicker',
    fieldProps: 'rangeTime1',
    fieldProps2: 'rangeTime2',
    title: '时间(month)',
    modeType: 'month',
    firstProps: {
      onOk: function onOk(val) {
        // eslint-disable-next-line no-console
        console.log(val);
      }
    }
  }]
}, {
  type: 'date',
  fieldProps: 'date',
  placeholder: '请选择',
  title: '出生年月'
}, {
  type: 'checkbox',
  fieldProps: 'fruit',
  title: '喜欢的水果',
  data: fruitData,
  required: true,
  disableItem: function disableItem(x) {
    return ['香梨'].some(function (a) {
      return x.value === a;
    });
  }
}, {
  type: 'multiplePicker',
  fieldProps: 'motion',
  placeholder: '请选择',
  title: '特长',
  data: motionData
}];

var UserName = function UserName() {
  var _useForm = useForm(),
      _useForm2 = _slicedToArray(_useForm, 1),
      form = _useForm2[0];

  var _useState = useState({}),
      _useState2 = _slicedToArray(_useState, 2),
      formsValues = _useState2[0],
      setFormsValues = _useState2[1];

  useEffect(function () {
    setFormsValues({
      sex: 'man',
      motion: ['羽毛球', '乒乓球']
    });
  }, []);

  var onFinish = function onFinish(values) {
    console.log(values);
  };

  var onFinishFailed = function onFinishFailed(errorInfo) {
    console.log('Failed:', errorInfo);
  };

  var formProps = {
    form: form,
    data: data,
    onFinish: onFinish,
    onFinishFailed: onFinishFailed,
    formsValues: formsValues
  };
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(DynamicForm, formProps), /*#__PURE__*/React.createElement(WhiteSpace, null), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: function onClick() {
      return form.submit();
    }
  }, "submit"));
};

export default UserName;