function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 重置错误信息提示
 */
export var resetErrorField = function resetErrorField(errorValue, values) {
  var errorObj = _objectSpread({}, errorValue);

  var key = Object.keys(values)[0];

  if (errorObj[key]) {
    errorObj[key] = undefined;
    return {
      success: true,
      errorObj: errorObj
    };
  } else {
    return {
      success: false
    };
  }
};
/**
 * 通过 onFinishFailed 的方法
 */

export var getAllError = function getAllError(errorInfo) {
  var _errorInfo$errorField = errorInfo.errorFields,
      errorFields = _errorInfo$errorField === void 0 ? [] : _errorInfo$errorField;
  var errorObj = {};
  errorFields.forEach(function (item) {
    errorObj[item["name"][0]] = item["errors"][0];
  });
  return errorObj;
};
/**
 * 滚动到错误的位置
 * @param errorInfo
 * @param onFinishFailed
 * @param failScroll
 * @returns
 */

export var defaultFailed = function defaultFailed(errorInfo, onFinishFailed, failScroll) {
  if (!errorInfo || !errorInfo.errorFields || errorInfo.errorFields.length === 0) {
    if (onFinishFailed) onFinishFailed(errorInfo);
    return;
  }

  var scrollToField = function scrollToField(fieldKey) {
    var labelNode = document.getElementById("alita-dform-".concat(fieldKey));

    if (labelNode && labelNode.scrollIntoView) {
      var _labelNode$scrollInto;

      (_labelNode$scrollInto = labelNode.scrollIntoView) === null || _labelNode$scrollInto === void 0 ? void 0 : _labelNode$scrollInto.call(labelNode, {
        behavior: 'smooth',
        block: 'center',
        inline: 'center'
      });
    }
  };

  if (failScroll) scrollToField(errorInfo.errorFields[0].name[0]);
  if (onFinishFailed) onFinishFailed(errorInfo);
};
export var getByteLen = function getByteLen(val) {
  var len = 0;
  "".concat(val).split('').forEach(function (item) {
    // eslint-disable-next-line no-control-regex
    if (item.match(/[^\x00-\xff]/gi) != null) {
      len += 2;
    } else {
      len += 1;
    }
  });
  return len;
};
export var changeData = function changeData(item, autoLineFeed) {
  if (item !== null && item !== void 0 && item.hidden) {
    item.required = false;
  }

  if (item.positionType === 'vertical' || !autoLineFeed) return item;

  if (item.title) {
    var titleSize = getByteLen(item.title);

    if (titleSize >= 16) {
      item.positionType = 'vertical';
    } else if (item.type === 'input' || item.type === 'extraInput') {
      if (titleSize > 8) {
        item.labelNumber = titleSize / 2 + 1;
      } else {
        item.labelNumber = 7;
      }
    }
  }

  return item;
};