import React from 'react';
import { InputItemPropsType } from 'antd-mobile-v2/es/input-item/PropsType';
import { DatePickerPropsType } from 'antd-mobile-v2/es/date-picker/PropsType';
import { Rule, FormInstance, Store, ValidateErrorEntity } from 'rc-field-form/es/interface';
export declare type InputEventHandler = (value?: string) => void;
export declare type StringAndUdfEvent = string | undefined;
export declare type StringEvent = string;
export declare type ClickEvent = React.MouseEvent<HTMLElement>;
export declare type ErrorValueProps = {
    [key: string]: string | undefined;
};
export declare type TitleTypePorps = 'addressPicker' | 'coverRadio' | 'extraInput' | 'multiplePicker' | 'input' | 'select' | 'picker' | 'switch' | 'area' | 'date' | 'radio' | 'checkbox' | 'image' | 'custom' | 'text' | 'file' | 'group' | 'rangeDatePicker';
export interface IAliasProps {
    label: string;
    value: string | number;
    desc?: string | number;
}
export interface IFormItemProps {
    type: 'input' | 'select' | 'area' | 'date' | 'switch' | 'extraInput' | 'radio' | 'rangeDatePicker' | 'coverRadio' | 'image' | 'custom' | 'multiplePicker' | 'addressPicker' | 'text' | 'picker' | 'file' | 'group' | 'checkbox';
    title: string;
    fieldProps?: string;
    fieldName?: string;
    required?: boolean;
    placeholder?: string;
    disabled?: boolean;
    data?: any[];
    inputType?: InputItemPropsType['type'];
    modeType?: DatePickerPropsType['mode'];
    fieldProps2?: string;
    placeholder2?: string;
    rules?: Rule[];
    extraType?: 'input' | 'select';
    editable?: boolean;
    rows?: number;
    labelNumber?: number;
    positionType?: 'vertical' | 'horizontal';
    hasStar?: boolean;
    firstProps?: any;
    secondProps?: any;
    radioType?: 'vertical' | 'horizontal';
    selectable?: boolean;
    limitSize?: number;
    CustomDom?: any;
    customDomProps?: any;
    subTitle?: string | React.ReactNode;
    maxValueLength?: number;
    onBlur?: (value?: string) => void;
    onChangeLevel?: (val: any) => void;
    placeholderList?: string[];
    chunk?: number;
    leftContent?: string | React.ReactNode;
    rightContent?: string | React.ReactNode;
    onClick?: any;
    height?: number | string;
    noData?: string | React.ReactNode;
    loading?: boolean;
    alias?: IAliasProps;
    maxLine?: number;
    compressRatio?: number;
    onChange?: (val: (string | number)[] | string | number | boolean) => void;
    hidden?: boolean;
    defaultValue?: any;
    coverStyle?: React.CSSProperties;
    renderHeader?: string | React.ReactNode;
    extra?: string | React.ReactNode;
    initKey?: string | number;
    className?: string;
    groupProps?: GroupProps;
    fileProps?: any;
}
export interface TargetProps {
    targetField: string;
    targetValue?: any;
    targetContent?: any;
}
export interface RelativesItemProps {
    type: 'changeFormValue' | 'required' | 'hidden' | 'disabled' | 'custom';
    targetValue: any[];
    targetSet: TargetProps[];
}
export interface IFormRelativesProps {
    [key: string]: RelativesItemProps[];
}
export interface IDynamicFormProps {
    children?: any;
    data?: IFormItemProps[];
    form: FormInstance;
    relatives?: IFormRelativesProps;
    formsValues?: Store;
    allDisabled?: boolean;
    onFinish?: (values: Store) => void;
    onFinishFailed?: (errorInfo: ValidateErrorEntity) => void;
    isDev?: boolean;
    onValuesChange?: (values: any) => void;
    autoLineFeed?: boolean;
    failScroll?: boolean;
    sonFlag?: boolean;
    errorFlag?: boolean;
}
export interface CardProps {
    leftView?: string | React.ReactNode;
    required?: boolean;
    title?: string | React.ReactNode;
    rightView?: string | React.ReactNode;
    className?: string;
    border?: boolean;
    extandPostion?: 'top' | 'bottom' | '';
    defaultExtand?: boolean;
    extandChange?: (res: boolean) => void;
    disabled?: boolean;
    hideStar?: boolean;
    children?: any;
    boxStyle?: React.CSSProperties;
    titleStyle?: React.CSSProperties;
}
export interface GroupProps extends CardProps {
    type?: 'empty' | 'card';
    children?: any;
}
export interface BaseComponentProps {
    title?: string;
    required?: boolean;
    fieldProps?: string;
    fieldName?: string;
    rules?: Rule[];
    hasStar?: boolean;
    positionType?: 'vertical' | 'horizontal';
    subTitle?: string | React.ReactNode;
    hidden?: boolean;
    className?: string;
    titleProps?: any;
    formFlag?: boolean;
    renderHeader?: string | React.ReactNode;
    renderFooter?: string | React.ReactNode;
    boxStyle?: React.CSSProperties;
    titleStyle?: React.CSSProperties;
    disabled?: boolean;
}
