"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultFailed = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antdMobileV = require("antd-mobile-v2");

var _rcFieldForm = _interopRequireWildcard(require("rc-field-form"));

var _components = require("../../components");

var _excluded = ["type"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var FormItemType = {
  input: _components.DformInput,
  select: _components.DformSelect,
  area: _components.DformTextArea,
  date: _components.DformDatePicker,
  switch: _components.DformSwitch,
  radio: _components.DformRadio,
  extraInput: _components.ExtraInput,
  rangeDatePicker: _components.RangeDatePicker,
  coverRadio: _components.CoverRadio,
  multiplePicker: _components.MultiplePicker,
  image: _components.DformImagePicker,
  checkbox: _components.DformCheckBox,
  text: _components.DformText,
  picker: _components.DformPicker
};
var radioList = [{
  label: '是',
  value: 'yes'
}, {
  label: '否',
  value: 'no'
}];
var EditFormItemLabel = {
  title: '标题',
  fieldProps: '绑定关键字',
  required: '是否必填',
  placeholder: '输入提示',
  disabled: '是否可编辑',
  data: '表单数据',
  inputType: '输入框类型',
  modeType: '选择器类型',
  fieldProps2: '副绑定关键字',
  placeholder2: '副输入提示',
  extraType: '扩展类型',
  type: '类型',
  positionType: '位置'
}; // inputType:'text' | 'bankCard' | 'phone' | 'password' | 'number' | 'digit' | 'money';
// modeType:mode?: 'datetime' | 'date' | 'year' | 'month' | 'time';

var EditFormItemType = {
  title: _components.DformInput,
  fieldProps: _components.DformInput,
  required: _components.DformSwitch,
  placeholder: _components.DformInput,
  disabled: _components.DformRadio,
  data: _components.DformInput,
  type: _components.DformInput,
  positionType: function positionType(props) {
    return /*#__PURE__*/_react.default.createElement(_components.DformSelect, _extends({
      data: [['horizontal', 'vertical'].map(function (item) {
        return {
          value: item,
          label: item
        };
      })],
      cols: 1
    }, props));
  },
  inputType: function inputType(props) {
    return /*#__PURE__*/_react.default.createElement(_components.DformSelect, _extends({
      data: [['text', 'bankCard', 'phone', 'password', 'number', 'digit', 'money'].map(function (item) {
        return {
          value: item,
          label: item
        };
      })],
      cols: 1
    }, props));
  },
  modeType: function modeType(props) {
    return /*#__PURE__*/_react.default.createElement(_components.DformSelect, _extends({
      data: [['datetime', 'date', 'year', 'month', 'time'].map(function (item) {
        return {
          value: item,
          label: item
        };
      })],
      cols: 1
    }, props));
  },
  fieldProps2: _components.DformInput,
  placeholder2: _components.DformInput,
  extraType: function extraType(props) {
    return /*#__PURE__*/_react.default.createElement(_components.DformSelect, _extends({
      data: [['input', 'select'].map(function (item) {
        return {
          value: item,
          label: item
        };
      })],
      cols: 1
    }, props));
  }
};

var getFormItem = function getFormItem(fieldItemKey) {
  var EditFormItemComponent = EditFormItemType[fieldItemKey];
  var title = EditFormItemLabel[fieldItemKey];
  return /*#__PURE__*/_react.default.createElement(EditFormItemComponent, {
    key: "alita-dform-edit-".concat(fieldItemKey),
    fieldProps: fieldItemKey,
    title: title,
    editable: fieldItemKey !== 'type'
  });
};

var getShowDeitItem = function getShowDeitItem(editData) {
  if (!editData) return;
  var _ref = editData,
      inputType = _ref.inputType,
      modeType = _ref.modeType,
      extraType = _ref.extraType,
      positionType = _ref.positionType;

  var _ref2 = editData,
      type = _ref2.type,
      otherProps = _objectWithoutProperties(_ref2, _excluded); // 选择类型的初始值要手动转化一下 2/3


  if (inputType) {
    inputType = inputType[0];
    otherProps.inputType = inputType;
  }

  if (modeType) {
    modeType = modeType[0];
    otherProps.modeType = modeType;
  }

  if (extraType) {
    extraType = extraType[0];
    otherProps.extraType = extraType;
  }

  if (positionType) {
    // eslint-disable-next-line prefer-destructuring
    positionType = positionType[0];
    otherProps.positionType = positionType;
  }

  var ShowItemComponent = FormItemType[type]; // eslint-disable-next-line consistent-return

  return /*#__PURE__*/_react.default.createElement(ShowItemComponent, otherProps);
};

var defaultFailed = function defaultFailed(errorInfo, onFinishFailed) {
  if (!errorInfo || !errorInfo.errorFields || errorInfo.errorFields.length === 0) {
    if (onFinishFailed) {
      onFinishFailed(errorInfo);
    }

    return;
  }

  var scrollToField = function scrollToField(fieldKey) {
    var labelNode = document.getElementById("aliat-dform-".concat(fieldKey));

    if (labelNode) {
      labelNode.scrollIntoView(true);
    }
  };

  scrollToField(errorInfo.errorFields[0].name[0]);
  if (onFinishFailed) onFinishFailed(errorInfo);
};

exports.defaultFailed = defaultFailed;

var EditForm = function EditForm(_ref3) {
  var _ref3$data = _ref3.data,
      data = _ref3$data === void 0 ? [] : _ref3$data,
      onChange = _ref3.onChange;

  var _useForm = (0, _rcFieldForm.useForm)(),
      _useForm2 = _slicedToArray(_useForm, 1),
      form = _useForm2[0]; // 选择类型的初始值要手动转化一下 1/3


  if (data.fieldProps) {
    // 加了随机数
    data.fieldProps = "".concat(Math.random().toString(36).slice(2, 6)).concat(data.fieldProps);
  }

  if (data.fieldProps2) {
    // 加了随机数
    data.fieldProps2 = "".concat(Math.random().toString(36).slice(2, 6)).concat(data.fieldProps2);
  }

  if (data.inputType) {
    data.inputType = [data.inputType];
  }

  if (data.modeType) {
    data.modeType = [data.modeType];
  }

  if (data.extraType) {
    data.extraType = [data.extraType];
  }

  if (data.positionType) {
    data.positionType = [data.positionType];
  }

  var _useState = (0, _react.useState)(_objectSpread({}, data)),
      _useState2 = _slicedToArray(_useState, 2),
      editData = _useState2[0],
      setEditData = _useState2[1];

  var onFinish = function onFinish(values) {
    // eslint-disable-next-line no-console
    console.log('Success:', values); // 选择类型的初始值要手动转化一下 3/3

    var newFormItem = _objectSpread({}, values);

    var inputType = newFormItem.inputType,
        modeType = newFormItem.modeType,
        extraType = newFormItem.extraType,
        type = newFormItem.type,
        positionType = newFormItem.positionType;

    if (inputType && typeof inputType !== 'string') {
      newFormItem.inputType = inputType[0];
    }

    if (modeType && typeof modeType !== 'string') {
      newFormItem.modeType = modeType[0];
    }

    if (extraType && typeof extraType !== 'string') {
      newFormItem.extraType = extraType[0];
    }

    if (positionType && typeof positionType !== 'string') {
      newFormItem.positionType = positionType[0];
    }

    if (type === 'radio' || type === 'coverRadio' || type === 'checkbox' || type === 'picker' || type === 'multiplePicker') {
      newFormItem.data = radioList;
    }

    if (type === 'select' || type === 'extraInput') {
      newFormItem.data = [radioList];
    } // newFormItem.type = 'input';


    if (onChange) onChange(newFormItem);
  };

  var _onFinishFailed = function onFinishFailed(errorInfo) {
    // eslint-disable-next-line no-console
    console.log('Failed:', errorInfo);
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      textAlign: 'left'
    }
  }, /*#__PURE__*/_react.default.createElement(_rcFieldForm.default, null, /*#__PURE__*/_react.default.createElement(_antdMobileV.List, {
    renderHeader: function renderHeader() {
      return '效果演示';
    }
  }, getShowDeitItem(editData))), /*#__PURE__*/_react.default.createElement(_rcFieldForm.default, {
    form: form,
    initialValues: _objectSpread({}, editData),
    onFinish: onFinish,
    onFinishFailed: function onFinishFailed(errorInfo) {
      return defaultFailed(errorInfo, _onFinishFailed);
    },
    onValuesChange: function onValuesChange(changFeil) {
      var newData = _objectSpread(_objectSpread({}, editData), changFeil);

      setEditData(newData);
    }
  }, /*#__PURE__*/_react.default.createElement(_antdMobileV.List, {
    renderHeader: function renderHeader() {
      return '编辑数据';
    }
  }, Object.keys(data || {}).filter(function (i) {
    return i !== 'data';
  }) // .filter(i => i !== 'type' && i !== 'data')
  .map(function (fieldItemKey) {
    return getFormItem(fieldItemKey);
  })), /*#__PURE__*/_react.default.createElement(_antdMobileV.WhiteSpace, {
    size: "lg"
  }), /*#__PURE__*/_react.default.createElement(_rcFieldForm.Field, null, /*#__PURE__*/_react.default.createElement(_antdMobileV.Button, {
    type: "primary",
    onClick: function onClick() {
      return form.submit();
    }
  }, "\u5B8C\u6210"))));
};

var _default = EditForm;
exports.default = _default;