"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Field = _interopRequireDefault(require("../Field"));

var _Context = require("../../baseComponents/Context");

var _Title = _interopRequireDefault(require("../../baseComponents/Title"));

var _AddressPickerGroup = _interopRequireDefault(require("./AddressPickerGroup"));

var _HorizontalTitle = _interopRequireDefault(require("../../baseComponents/HorizontalTitle"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var AddressPicker = function AddressPicker(props) {
  var fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      title = props.title,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'horizontal' : _props$positionType,
      extra = props.extra,
      onChange = props.onChange,
      defaultValue = props.defaultValue,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      boxStyle = props.boxStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      titleStyle = props.titleStyle,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled;
  var fieldKey = fieldName || fieldProps;

  var _useContext = (0, _react.useContext)(_Context.CardContext),
      cDisabled = _useContext.cDisabled;

  var _useState = (0, _react.useState)(disabled || cDisabled),
      _useState2 = _slicedToArray(_useState, 2),
      mregedDisabled = _useState2[0],
      setMregedDisabled = _useState2[1];

  var _useContext2 = (0, _react.useContext)(_Context.DformContext),
      changeForm = _useContext2.changeForm;

  var isVertical = positionType === 'vertical';
  (0, _react.useMemo)(function () {
    var _changeForm$fieldKey;

    if (cDisabled) return;

    if (((_changeForm$fieldKey = changeForm[fieldKey]) === null || _changeForm$fieldKey === void 0 ? void 0 : _changeForm$fieldKey.disabled) !== undefined) {
      var _changeForm$fieldKey2;

      setMregedDisabled((_changeForm$fieldKey2 = changeForm[fieldKey]) === null || _changeForm$fieldKey2 === void 0 ? void 0 : _changeForm$fieldKey2.disabled);
    } else {
      setMregedDisabled(disabled);
    }
  }, [changeForm[fieldKey], disabled, cDisabled]);

  var fieldChange = function fieldChange(val) {
    if (onChange) onChange(val);
  };

  var showAddressPickerFiled = function showAddressPickerFiled() {
    return /*#__PURE__*/_react.default.createElement(_AddressPickerGroup.default, _extends({
      value: defaultValue
    }, props, {
      fieldProps: fieldKey,
      disabled: mregedDisabled,
      extra: extra,
      onChange: fieldChange
    }), /*#__PURE__*/_react.default.createElement(_HorizontalTitle.default, {
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldKey,
      titleStyle: titleStyle
    }));
  };

  return /*#__PURE__*/_react.default.createElement(_Title.default, {
    independentProps: props,
    type: "addressPicker",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/_react.default.createElement(_Field.default, {
    title: title,
    required: required,
    rules: rules,
    name: fieldKey,
    shouldUpdate: function shouldUpdate(prevValue, nextValue) {
      return prevValue !== nextValue;
    },
    initialValue: defaultValue,
    params: {
      hidden: hidden,
      formFlag: formFlag
    },
    type: "addressPicker"
  }, showAddressPickerFiled()));
};

AddressPicker.displayName = 'addressPicker';
var _default = AddressPicker;
exports.default = _default;