"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _rcFieldForm = require("rc-field-form");

var _Context = require("../../baseComponents/Context");

var _menu = require("../../utils/menu");

require("../../styles/index.less");

var _excluded = ["rules", "params", "style", "required", "title", "type", "name"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CustomField = function CustomField(props) {
  var _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      _props$params = props.params,
      params = _props$params === void 0 ? {} : _props$params,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      _props$title = props.title,
      title = _props$title === void 0 ? '' : _props$title,
      type = props.type,
      name = props.name,
      restProps = _objectWithoutProperties(props, _excluded);

  var _params$hidden = params.hidden,
      hidden = _params$hidden === void 0 ? false : _params$hidden,
      _params$formFlag = params.formFlag,
      fFlag = _params$formFlag === void 0 ? true : _params$formFlag;

  var _useState = (0, _react.useState)(required),
      _useState2 = _slicedToArray(_useState, 2),
      mregedRequired = _useState2[0],
      setMregedRequired = _useState2[1];

  var _useState3 = (0, _react.useState)(hidden),
      _useState4 = _slicedToArray(_useState3, 2),
      mregedHidden = _useState4[0],
      setMregedHidden = _useState4[1];

  var _useContext = (0, _react.useContext)(_Context.DformContext),
      changeForm = _useContext.changeForm,
      _useContext$formFlag = _useContext.formFlag,
      formFlag = _useContext$formFlag === void 0 ? false : _useContext$formFlag,
      updateErrorValue = _useContext.updateErrorValue;

  (0, _react.useMemo)(function () {
    var _changeForm$name, _changeForm$name3;

    if (((_changeForm$name = changeForm[name]) === null || _changeForm$name === void 0 ? void 0 : _changeForm$name.required) !== undefined) {
      var _changeForm$name2;

      setMregedRequired((_changeForm$name2 = changeForm[name]) === null || _changeForm$name2 === void 0 ? void 0 : _changeForm$name2.required);
    } else {
      setMregedRequired(required);
    }

    if (((_changeForm$name3 = changeForm[name]) === null || _changeForm$name3 === void 0 ? void 0 : _changeForm$name3.hidden) !== undefined) {
      var _changeForm$name4;

      setMregedHidden((_changeForm$name4 = changeForm[name]) === null || _changeForm$name4 === void 0 ? void 0 : _changeForm$name4.hidden);
    } else {
      setMregedHidden(hidden);
    }
  }, [changeForm[name], hidden, required]);

  var shouldUpdate = function shouldUpdate(prevValue, nextValue) {
    if (prevValue[props === null || props === void 0 ? void 0 : props.name] !== nextValue[props === null || props === void 0 ? void 0 : props.name]) {
      if (updateErrorValue) updateErrorValue(name);
    }

    if (props.shouldUpdate && typeof props.shouldUpdate === 'function') {
      props.shouldUpdate(prevValue, nextValue, {});
    }

    return prevValue !== nextValue;
  }; // 不在DynamicForm中 取消Field包裹;


  if (!formFlag || !fFlag) {
    return /*#__PURE__*/_react.default.createElement("div", {
      id: "alita-dform-".concat(props === null || props === void 0 ? void 0 : props.name)
    }, props.children);
  }

  return /*#__PURE__*/_react.default.createElement("div", {
    id: "alita-dform-".concat(props === null || props === void 0 ? void 0 : props.name),
    style: style
  }, /*#__PURE__*/_react.default.createElement(_rcFieldForm.Field, _extends({}, restProps, {
    name: name,
    rules: mregedHidden ? [] : [].concat(_toConsumableArray(rules || []), [{
      required: mregedRequired,
      message: "".concat(_menu.PLACEHOLDER_MENU[type]).concat(title)
    }]),
    shouldUpdate: shouldUpdate
  })));
};

var _default = CustomField;
exports.default = _default;