"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _Field = _interopRequireDefault(require("../Field"));

var _Title = _interopRequireDefault(require("../../baseComponents/Title"));

var _CustomGroup = _interopRequireDefault(require("./CustomGroup"));

var _HorizontalTitle = _interopRequireDefault(require("../../baseComponents/HorizontalTitle"));

var _const = require("../../const");

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DformCustom = function DformCustom(props) {
  var defaultValue = props.defaultValue,
      fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      title = props.title,
      CustomDom = props.CustomDom,
      customDomProps = props.customDomProps,
      children = props.children,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? 'vertical' : _props$positionType,
      _props$labelNumber = props.labelNumber,
      labelNumber = _props$labelNumber === void 0 ? 7 : _props$labelNumber,
      onChange = props.onChange,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden;
  var isVertical = positionType === 'vertical';
  var fieldKey = fieldName || fieldProps;
  (0, _react.useEffect)(function () {
    if (CustomDom || customDomProps) {
      console.warn('DformCustom组件已放弃CustomDom、customDomProps属性，请切换为children');
    }
  }, [CustomDom, customDomProps]);

  var cutomTitle = function cutomTitle() {
    return /*#__PURE__*/_react.default.createElement(_HorizontalTitle.default, {
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldKey,
      titleStyle: titleStyle
    });
  };

  var fieldChange = function fieldChange(e) {
    if (onChange) onChange(e);
  };

  return /*#__PURE__*/_react.default.createElement(_Title.default, {
    independentProps: props,
    type: "custom",
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames2.default)(_defineProperty({}, "".concat(_const.allPrefixCls, "-dom"), true))
  }, !isVertical && cutomTitle(), /*#__PURE__*/_react.default.createElement(_Field.default, {
    name: fieldKey,
    title: title,
    required: required,
    rules: rules,
    initialValue: defaultValue,
    type: "custom",
    params: {
      hidden: hidden,
      formFlag: formFlag
    }
  }, /*#__PURE__*/_react.default.createElement(_CustomGroup.default, {
    isVertical: isVertical,
    CustomDom: CustomDom,
    customDomProps: customDomProps,
    cutomTitle: cutomTitle(),
    onChange: fieldChange,
    children: children
  }))));
};

DformCustom.displayName = 'dformCustom';
var _default = DformCustom;
exports.default = _default;