"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Context = require("../../baseComponents/Context");

var _classnames3 = _interopRequireDefault(require("classnames"));

var _Field = _interopRequireDefault(require("../Field"));

var _Title = _interopRequireDefault(require("../../baseComponents/Title"));

var _HorizontalTitle = _interopRequireDefault(require("../../baseComponents/HorizontalTitle"));

var _const = require("../../const");

var _DatePickerGroup = _interopRequireDefault(require("./DatePickerGroup"));

var _utils = require("../../utils");

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DformDatePicker = function DformDatePicker(props) {
  var _classnames2;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      beginDate = _useState2[0],
      setBeginDate = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = _slicedToArray(_useState3, 2),
      endDate = _useState4[0],
      setEndDate = _useState4[1];

  var fieldProps = props.fieldProps,
      fieldName = props.fieldName,
      _props$fieldProps = props.fieldProps2,
      fieldProps2 = _props$fieldProps === void 0 ? '' : _props$fieldProps,
      _props$secondProps = props.secondProps,
      secondProps = _props$secondProps === void 0 ? {} : _props$secondProps,
      _props$required = props.required,
      required = _props$required === void 0 ? false : _props$required,
      title = props.title,
      _props$rules = props.rules,
      rules = _props$rules === void 0 ? [] : _props$rules,
      _props$positionType = props.positionType,
      positionType = _props$positionType === void 0 ? props.fieldProps2 ? 'vertical' : 'horizontal' : _props$positionType,
      _props$hasStar = props.hasStar,
      hasStar = _props$hasStar === void 0 ? true : _props$hasStar,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      onChange = props.onChange,
      defaultValue = props.defaultValue,
      _props$coverStyle = props.coverStyle,
      coverStyle = _props$coverStyle === void 0 ? {} : _props$coverStyle,
      labelNumber = props.labelNumber,
      minDate = props.minDate,
      maxDate = props.maxDate,
      _props$modeType = props.modeType,
      modeType = _props$modeType === void 0 ? 'date' : _props$modeType,
      _props$hidden = props.hidden,
      hidden = _props$hidden === void 0 ? false : _props$hidden,
      boxStyle = props.boxStyle,
      titleStyle = props.titleStyle,
      _props$formFlag = props.formFlag,
      formFlag = _props$formFlag === void 0 ? true : _props$formFlag,
      replaceName = props.replaceName;
  var fieldKey = fieldName || fieldProps;
  var _secondProps$disabled = secondProps.disabled,
      secondDisabled = _secondProps$disabled === void 0 ? false : _secondProps$disabled;

  var _useContext = (0, _react.useContext)(_Context.CardContext),
      cDisabled = _useContext.cDisabled;

  var _useState5 = (0, _react.useState)(disabled || cDisabled),
      _useState6 = _slicedToArray(_useState5, 2),
      mregedDisabled = _useState6[0],
      setMregedDisabled = _useState6[1];

  var _useState7 = (0, _react.useState)(secondDisabled || cDisabled),
      _useState8 = _slicedToArray(_useState7, 2),
      sMregedDisabled = _useState8[0],
      setSMregedDisabled = _useState8[1];

  var _useContext2 = (0, _react.useContext)(_Context.DformContext),
      changeForm = _useContext2.changeForm;

  (0, _react.useMemo)(function () {
    var _changeForm$fieldKey;

    if (cDisabled) return;

    if (((_changeForm$fieldKey = changeForm[fieldKey]) === null || _changeForm$fieldKey === void 0 ? void 0 : _changeForm$fieldKey.disabled) !== undefined) {
      var _changeForm$fieldKey2;

      setMregedDisabled((_changeForm$fieldKey2 = changeForm[fieldKey]) === null || _changeForm$fieldKey2 === void 0 ? void 0 : _changeForm$fieldKey2.disabled);
    } else {
      setMregedDisabled(disabled);
    }
  }, [changeForm[fieldKey], disabled, cDisabled]);
  (0, _react.useMemo)(function () {
    var _changeForm$fieldProp;

    if (cDisabled) return;

    if (fieldProps2 && ((_changeForm$fieldProp = changeForm[fieldProps2]) === null || _changeForm$fieldProp === void 0 ? void 0 : _changeForm$fieldProp.disabled) !== undefined) {
      var _changeForm$fieldProp2;

      setSMregedDisabled((_changeForm$fieldProp2 = changeForm[fieldProps2]) === null || _changeForm$fieldProp2 === void 0 ? void 0 : _changeForm$fieldProp2.disabled);
    } else {
      setSMregedDisabled(secondDisabled);
    }
  }, [changeForm[fieldProps2], secondDisabled, cDisabled]);
  var isVertical = positionType === 'vertical'; // const fileChange = (e: any) => {
  //   if (onChange) onChange(e);
  // };

  var renderDatePicker = function renderDatePicker(_ref) {
    var _classnames;

    var _ref$fieldProps = _ref.fieldProps,
        fieldProps = _ref$fieldProps === void 0 ? {} : _ref$fieldProps,
        _ref$type = _ref.type,
        type = _ref$type === void 0 ? 'left' : _ref$type,
        dateProps = _ref.dateProps,
        _ref$isBegin = _ref.isBegin,
        isBegin = _ref$isBegin === void 0 ? false : _ref$isBegin,
        _ref$isEnd = _ref.isEnd,
        isEnd = _ref$isEnd === void 0 ? false : _ref$isEnd;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: (0, _classnames3.default)((_classnames = {}, _defineProperty(_classnames, "alitajs-dform".concat(isVertical ? '-vertical' : '', "-date-picker"), !isBegin && !isEnd), _defineProperty(_classnames, "".concat(_const.allPrefixCls, "-begin").concat(isVertical ? '-vertical' : '', "-picker"), isBegin), _defineProperty(_classnames, "".concat(_const.allPrefixCls, "-end").concat(isVertical ? '-vertical' : '', "-picker"), isEnd), _defineProperty(_classnames, 'alitajs-dform-disabled', mregedDisabled), _classnames))
    }, /*#__PURE__*/_react.default.createElement(_Field.default, _extends({
      title: title,
      required: required,
      rules: rules
    }, fieldProps, {
      params: {
        hidden: hidden,
        formFlag: formFlag
      },
      type: "date"
    }), /*#__PURE__*/_react.default.createElement(_DatePickerGroup.default, _extends({
      format: function format(value) {
        return (0, _utils.changeDateFormat)({
          value: value,
          modeType: modeType
        });
      }
    }, dateProps, {
      mode: modeType,
      replaceName: replaceName
    }), !isVertical && type === 'left' && /*#__PURE__*/_react.default.createElement(_HorizontalTitle.default, _extends({
      required: required,
      hasStar: hasStar,
      title: title,
      labelNumber: labelNumber,
      isVertical: isVertical,
      fieldProps: fieldProps.name,
      titleStyle: titleStyle
    }, fieldProps)))));
  }; // 默认第一个时间field


  var firstFieldProps = {
    name: fieldKey,
    initialValue: defaultValue
  }; // 存在区间时

  if (fieldProps2) {
    firstFieldProps.shouldUpdate = function (prevValue, nextValue) {
      setBeginDate(nextValue && nextValue[fieldKey]);
      return prevValue !== nextValue;
    };
  } // 区间第二个field


  var secondFieldProps = {
    name: fieldProps2,
    initialValue: secondProps === null || secondProps === void 0 ? void 0 : secondProps.defaultValue,
    shouldUpdate: function shouldUpdate(prevValue, nextValue) {
      setEndDate(nextValue && nextValue[fieldProps2]);
      return prevValue !== nextValue;
    },
    disabled: sMregedDisabled
  }; // 默认第一个时间props

  var firstDateProps = _objectSpread({
    value: defaultValue
  }, props); // 存在区间时


  if (fieldProps2) {
    firstDateProps.title = title;
    firstDateProps.coverStyle = _objectSpread(_objectSpread({}, coverStyle), {}, {
      textAlign: 'center'
    });

    firstDateProps.onChange = function (e) {
      setBeginDate(e);
      onChange && onChange(e);
    };

    firstDateProps.labelNumber = isVertical ? 0 : labelNumber; // firstDateProps.arrow = false;

    firstDateProps.maxDate = endDate || maxDate;
  } // 区间第二个时间props


  var secondDateProps = _objectSpread(_objectSpread(_objectSpread({}, props), secondProps), {}, {
    labelNumber: 0,
    minDate: beginDate || minDate,
    maxDate: maxDate,
    onChange: function onChange(e) {
      setEndDate(e);
      secondProps && (secondProps === null || secondProps === void 0 ? void 0 : secondProps.onChange) && (secondProps === null || secondProps === void 0 ? void 0 : secondProps.onChange(e));
    },
    coverStyle: _objectSpread(_objectSpread({}, coverStyle), {}, {
      textAlign: 'center'
    })
  });

  return /*#__PURE__*/_react.default.createElement(_Title.default, {
    type: "date",
    independentProps: _objectSpread({
      positionType: positionType
    }, props),
    style: boxStyle,
    titleStyle: titleStyle
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames3.default)((_classnames2 = {}, _defineProperty(_classnames2, "".concat(_const.allPrefixCls, "-range-horizontal"), !isVertical), _defineProperty(_classnames2, "".concat(_const.allPrefixCls, "-range-date-picker"), true), _classnames2))
  }, renderDatePicker({
    fieldProps: firstFieldProps,
    dateProps: firstDateProps,
    isBegin: !!fieldProps2
  }), !!fieldProps2 && /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_const.allPrefixCls, "-line")
  }, "~"), !!fieldProps2 && renderDatePicker({
    fieldProps: secondFieldProps,
    type: 'right',
    dateProps: secondDateProps,
    isEnd: !!fieldProps2
  })));
};

DformDatePicker.displayName = 'dformDatePicker';
var _default = DformDatePicker;
exports.default = _default;